%% estimate Bacterial fitness model partially obs 

deb=0;
fin=8;
h_var = 0.08;

x0= [0 600 2];

gamma = 2.4*10^-4;
rho = 10^-6;
psi = 0.7;
c = 0.1;


beta = 3;
Pmax = 1.8*10^5;
delta = 6*10^-6;
delta_p = 1.512;
nu_s = 24;
K = 10^9;
E_s =  36;
A = 4;
A_s50 = 0.25;

gamma_max = 0.035;
A_s = 4;
gamma_50 = 5;
lambda = 10^-5;

A_r50 = 5;
E_r = 26.4;

theta = [gamma  rho psi c];
theta_log = [log(theta(1)) log(theta(2)) log(theta(3)) log(theta(4))];
theta_fixe = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r];

theta_sp = [gamma  psi c];
theta_log_sp = [log(theta(1))  log(theta(3)) log(theta(4))];
theta_fixe_sp = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r rho];

std = 2;
control = @(t)([0 0 0]');


% base_func= @(t)([sin(t) sin(2*t) sin(3*t) sin(4*t)]');
% coeff_c = 10*randn(3,4);
% control_rand = @(t)(coeff_c*base_func(t));

coeff_c = 5;
c_decr = 0.01;
control_rand = @(t)([coeff_c*randn(1,1) 0 coeff_c*randn(1,1)]');


 [T1 Y1] = bacterial_fitness_sim(deb,h_var,fin,theta,theta_fixe,x0,0,control);
 [T1_tr Y1_tr] = bacterial_fitness_decr_eff_sim(deb,h_var,fin,theta,theta_fixe,x0,c_decr,0);
 
 sum(sum((Y1 -  Y1_tr).^2))

 
  plot(T1_tr,Y1_tr(:,1),'b',T1_tr,Y1_tr(:,2),'g',T1_tr,Y1_tr(:,3),'r')
  hold on
  plot(T1,Y1(:,1),'b',T1,Y1(:,2),'g',T1,Y1(:,3),'r')
%  plot(T1_tr,Y1_tr(:,2),'g')
%  hold on
%  plot(T1,Y1(:,2),'g')
% 
%  
%   Y_bact = Y1(:,2) + Y1(:,3);
%   Obs_l = Observation(T1,[Y1(:,1) Y_bact]);
%   bs_l = bSplines(Obs_l);
%   bs_l.erreur(1);
%   
%   hold on 
%  val_1_x1 = arrayfun(@(t)(1-bs_l.calcul_prediction(t)^2),deb:h_var:fin);
%  plot(deb:h_var:fin,val_1_x1,'r',deb:h_var:fin,(b/(c^2))*ones(length(deb:h_var:fin),1),'g')

%% Pontryagin Discretized version

%mat_C = eye(3);
%Sim_obs = Y1';
 
mat_C = zeros(2,3);
mat_C(1,1) = 1;
mat_C(2,2) = 1;
mat_C(2,3) = 1
Sim_obs = [Y1(:,1) Y_bact]';
% 
mat_B = eye(3);
lambda = 10^19;
vect_weight = (10^-20)*ones(length(T1)-1,1);


v_field_exp_sp = @(t,vx,param)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);

  [retain_residual,retain_solution,est_p0] = compute_pontryagin_solution_discretizedODE(T1,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field_exp_sp,der_v_field_exp_sp,theta_log_sp,x0)

  %% Pontryagin Discretized version: scaled version

scaled_param = 1000  

% mat_C = eye(3);
% Sim_obs = Y1'/scaled_param;
 
mat_C = zeros(2,3);
mat_C(1,1) = 1;
mat_C(2,2) = 1;
mat_C(2,3) = 1;
Sim_obs = [Y1(:,1) Y_bact]'/scaled_param;
% 
mat_B = eye(3);
lambda = 1000000;
vect_weight = (10^-20)*ones(length(T1)-1,1);


v_field_exp_sp = @(t,vx,param)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);

v_field_exp_sp_scaled = @(t,vx,param)(v_field_exp_sp(t,scaled_param*vx,param)/scaled_param);
der_v_field_exp_sp_scaled  = @(t,vx,param)der_vect_field_bact_fitness_exp_sp(t,scaled_param*vx,param,theta_fixe_sp);


  [retain_residual,retain_solution,est_p0] = compute_pontryagin_solution_discretizedODE(T1,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field_exp_sp_scaled,der_v_field_exp_sp_scaled,theta_log_sp,x0/scaled_param)

%% Pontryagin Discretized version: Trial value for eight and lambda 

val_lambda_trial = [10^-2 0.1 1 10 10^2 10^3 10^4 10^5 10^6 10^7 10^8 10^9 10^10]
val_weight_trial = [10^2 10^1 10^-1 10^-2 10^-3 10^-4 10^-5 10^-6 10^-7 10^-8 10^-9 10^-10 10^-11 10^-12]

mat_val_est = zeros(length(val_lambda_trial),3,length(val_weight_trial));
mat_val_est_dc = zeros(length(val_lambda_trial),3,length(val_weight_trial));

warning off

for nl = 1 : length(val_lambda_trial)
    for nw = 1 :length(val_weight_trial)
        lambda = val_lambda_trial(nl);
        vect_weight = val_weight_trial(nw)*ones(length(T1)-1,1);
    try
    [est_param,Sval] = param_estimation_pontryagin_discretizedODE(T1,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field_exp_sp,der_v_field_exp_sp,theta_log_sp,x0,20)
     mat_val_est(nl,:,nw) = est_param;
    catch
        'echec' 
        nl
        nw
    end
    try
    [est_param_dc,Sval] = param_estimation_pontryagin_discretizedODE(T1,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field_exp_sp,der_v_field_exp_sp,1.2*theta_log_sp,x0,20)
    mat_val_est_dc(nl,:,nw) = est_param_dc;
    catch
       'echec dc' 
        nl
        nw
    end
    
    end
end

%% Estimate optimal control

v_field_exp_sp = @(t,vx,param,pf)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

mat_U = 500*eye(3);

bs_u = est_control_pontryagin(bs_l,v_field_exp_sp,der_v_field_exp_sp,mat_obs_c,mat_U,theta_log_sp,x0)

%%
intervalle_int = zeros(10,2);
intervalle_int(1,:) = [0 T1(10)];
intervalle_int(2,:) = [T1(10) T1(20)];
intervalle_int(3,:) = [T1(20) T1(30)];
intervalle_int(4,:) = [T1(30) T1(40)];
intervalle_int(5,:) = [T1(40) T1(50)];
intervalle_int(6,:) = [T1(50) T1(60)];
intervalle_int(7,:) = [T1(60) T1(70)];
intervalle_int(8,:) = [T1(70) T1(80)];
intervalle_int(9,:) = [T1(80) T1(90)];
intervalle_int(10,:) = [T1(90) T1(100)];

% intervalle_int = zeros(2,2);
% intervalle_int(1,:) = [0 T1(50)];
% intervalle_int(2,:) = [T1(50) T1(100)];


res_err_pred = pontryagin_prediction_error_multi_inter(bs_l,bs_u,v_field_exp_sp,mat_obs_c,theta_log_sp,x0,intervalle_int)

%%
[discrepancy_state_observation, discrepancy_pure_observation,correlation_value, correlation_vfield_control]...
    = pontryagin_new_hyperparameter_selection(bs_l,bs_u,v_field_exp_sp,mat_obs_c,theta_log_sp,x0)

%% sloppy parameter analysis


 
v_field = @(t,vx,param,pf)vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field = @(t,vx,param,pf)der_vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_theta = @(t,vx,param,pf)der_param_vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_state_theta = @(t,vx,param,pf) der_vect_param_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_state_state = @(t,vx,param,pf)der_sec_vect_field_bact_fitness(t,vx,param,theta_fixe);


mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

matrix_sloppy = compute_sloppy_parameter_matrix(T1,theta,v_field,der_v_field,der_v_field_theta,mat_obs_c,x0);

[V U] = eig(matrix_sloppy);
V
spectrum = diag(U)

%% sloppy parameter analysis: simplified version


 
v_field_sp = @(t,vx,param,pf)vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_theta_sp  = @(t,vx,param,pf)der_param_vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_theta_sp  = @(t,vx,param,pf) der_vect_param_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_state_sp  = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);


mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

matrix_sloppy = compute_sloppy_parameter_matrix(T1,theta_sp,v_field_sp ,der_v_field_sp ,der_v_field_theta_sp ,mat_obs_c,x0);

[V U] = eig(matrix_sloppy);
V
spectrum = diag(U)


%% sloppy parameter analysis: log transformation


v_field_exp = @(t,vx,param,pf)vect_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_exp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_theta_exp = @(t,vx,param,pf)der_param_vect_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_state_theta_exp = @(t,vx,param,pf) der_state_param_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_state_state_exp = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_exp(t,vx,param,theta_fixe);


mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

matrix_sloppy = compute_sloppy_parameter_matrix(T1,theta_log,v_field_exp,der_v_field_exp,der_v_field_theta_exp,mat_obs_c,x0);

[V U] = eig(matrix_sloppy);
V
spectrum = diag(U)

%% sloppy parameter analysis: log transformation simplified version


v_field_exp_sp = @(t,vx,param,pf)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_theta_exp_sp = @(t,vx,param,pf)der_param_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_theta_exp_sp = @(t,vx,param,pf) der_state_param_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_state_exp_sp = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);


mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

matrix_sloppy = compute_sloppy_parameter_matrix(T1,theta_log_sp,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,mat_obs_c,x0);

[V U] = eig(matrix_sloppy);
V
spectrum = diag(U)

%%
lambda_trial = [0.1 1 10 100 1000 10000 100000 10^6 10^7];
mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

 
v_field = @(t,vx,param,pf)vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field = @(t,vx,param,pf)der_vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_theta = @(t,vx,param,pf)der_param_vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_state_theta = @(t,vx,param,pf) der_vect_param_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_state_state = @(t,vx,param,pf)der_sec_vect_field_bact_fitness(t,vx,param,theta_fixe);


v_field_exp = @(t,vx,param,pf)vect_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_exp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_theta_exp = @(t,vx,param,pf)der_param_vect_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_state_theta_exp = @(t,vx,param,pf) der_state_param_field_bact_fitness_exp(t,vx,param,theta_fixe);
der_v_field_state_state_exp = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_exp(t,vx,param,theta_fixe);

 
v_field_sp = @(t,vx,param,pf)vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_theta_sp  = @(t,vx,param,pf)der_param_vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_theta_sp  = @(t,vx,param,pf) der_vect_param_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_state_sp  = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_sp(t,vx,param,theta_fixe_sp);


v_field_exp_sp = @(t,vx,param,pf)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_theta_exp_sp = @(t,vx,param,pf)der_param_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_theta_exp_sp = @(t,vx,param,pf) der_state_param_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_state_exp_sp = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);



mat_est_oc = zeros(length(lambda_trial),length(theta));
mat_est_oc_dc = zeros(length(lambda_trial),length(theta));


mat_est_oc_sp = zeros(length(lambda_trial),length(theta_sp));
mat_est_oc_sp_dc = zeros(length(lambda_trial),length(theta_sp));

mat_est_oc_exp = zeros(length(lambda_trial),length(theta));
mat_est_oc_exp_dc = zeros(length(lambda_trial),length(theta));


mat_est_oc_exp_sp = zeros(length(lambda_trial),length(theta_sp) );
mat_est_oc_exp_sp_dc = zeros(length(lambda_trial),length(theta_sp));

mat_err_pred_multi_int = zeros(1,length(lambda_trial));

theta_log_sp

   theta_ini_sp_dc = 0.7*theta_sp;
   theta_ini_sp= theta_sp;
   theta_ini_exp_sp = theta_log_sp;
   theta_ini_exp_sp_dc = 0.7*theta_log_sp;
   
intervalle_int = zeros(10,2);
intervalle_int(1,:) = [0 T1(10)];
intervalle_int(2,:) = [T1(10) T1(20)];
intervalle_int(3,:) = [T1(20) T1(30)];
intervalle_int(4,:) = [T1(30) T1(40)];
intervalle_int(5,:) = [T1(40) T1(50)];
intervalle_int(6,:) = [T1(50) T1(60)];
intervalle_int(7,:) = [T1(60) T1(70)];
intervalle_int(8,:) = [T1(70) T1(80)];
intervalle_int(9,:) = [T1(80) T1(90)];
intervalle_int(10,:) = [T1(90) T1(100)];


for nl = 1 : length(lambda_trial)
	mat_U = lambda_trial(nl)*eye(3);
    
  
    
   % [est_param_sp,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field_sp,der_v_field_sp,der_v_field_theta_sp,der_v_field_state_theta_sp,der_v_field_state_state_sp,mat_obs_c,mat_U,theta_ini_sp,x0);
	%[est_param_sp_dc,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field_sp,der_v_field_sp,der_v_field_theta_sp,der_v_field_state_theta_sp,der_v_field_state_state_sp,mat_obs_c,mat_U,theta_ini_sp_dc,x0);
    
    [est_param_exp_sp,fval_g,bs_u] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,der_v_field_state_theta_exp_sp,der_v_field_state_state_exp_sp,mat_obs_c,mat_U,theta_ini_exp_sp,x0);
    
    res_err_pred = pontryagin_prediction_error_multi_inter(bs_l,bs_u,v_field_exp_sp,mat_obs_c,est_param_exp_sp,x0,intervalle_int);
%	[est_param_exp_sp_dc,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,der_v_field_state_theta_exp_sp,der_v_field_state_state_exp_sp,mat_obs_c,mat_U,theta_ini_exp_sp_dc,x0);

    
    %   theta_ini_sp_dc = est_param_sp_dc;
    %   theta_ini_sp= est_param_sp;
%       theta_ini_exp_sp = est_param_exp_sp
%       theta_ini_exp_sp_dc = est_param_exp_sp_dc;
%     
% 	[est_param,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,theta,x0);
% 	[est_param_dc,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.7*theta,x0);
%     
%     [est_param_exp,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field_exp,der_v_field_exp,der_v_field_theta_exp,der_v_field_state_theta_exp,der_v_field_state_state_exp,mat_obs_c,mat_U,theta_log,x0);
% 	[est_param_exp_dc,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field_exp,der_v_field_exp,der_v_field_theta_exp,der_v_field_state_theta_exp,der_v_field_state_state_exp,mat_obs_c,mat_U,0.7*theta_log,x0);
% 
% 	
% 	mat_est_oc(nl,:) = est_param;
% 	mat_est_oc_dc(nl,:) = est_param_dc;
%     
%     mat_est_oc_exp(nl,:) = est_param_exp;
% 	mat_est_oc_exp_dc(nl,:) = est_param_exp_dc;
%     
    %mat_est_oc_sp(nl,:) = est_param_sp;
	%mat_est_oc_sp_dc(nl,:) = est_param_sp_dc;
    
    mat_est_oc_exp_sp(nl,:) = est_param_exp_sp;
    mat_err_pred_multi_int(nl) = res_err_pred;
	%mat_est_oc_exp_sp_dc(nl,:) = est_param_exp_sp_dc;


end


% [est_param_nls_exp,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,mat_obs_c,theta_log_sp,x0)
% [est_param_nls_exp_dc,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,mat_obs_c,0.7*theta_log_sp,x0)
 
 
%%
intervalle_int3 = zeros(3,2);
intervalle_int3(1,:) = [0 T1(33)];
intervalle_int3(2,:) = [T1(33) T1(66)];
intervalle_int3(3,:) = [T1(66) T1(100)];



mat_err_pred_multi_int3 = zeros(1,length(lambda_trial));

for nl = 1 : length(lambda_trial)
    
    mat_U = lambda_trial(nl)*eye(3);

    bs_u = est_control_pontryagin(bs_l,v_field_exp_sp,der_v_field_exp_sp,mat_obs_c,mat_U,mat_est_oc_exp_sp(nl,:),x0)
  
    res_err_pred = pontryagin_prediction_error_multi_inter(bs_l,bs_u,v_field_exp_sp,mat_obs_c,mat_est_oc_exp_sp(nl,:),x0,intervalle_int3);

    mat_err_pred_multi_int3(nl) = res_err_pred;



end
%%

 [est_param_nls,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,mat_obs_c,theta,x0)
 [est_param_nls_dc,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,mat_obs_c,0.7*theta,x0)
 
 %%
 
  [est_param_nls_exp,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,mat_obs_c,theta_log_sp,x0)
 [est_param_nls_exp_dc,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,mat_obs_c,0.7*theta_log_sp,x0)
 
 
%%
 

nb_run = 100;

deb=0;
fin=8;
h_var = 0.08;

x0= [0 600 2];

gamma = 2.4*10^-4;
rho = 10^-6;
psi = 0.7;
c = 0.1;


beta = 3;
Pmax = 1.8*10^5;
delta = 6*10^-6;
delta_p = 1.512;
nu_s = 24;
K = 10^9;
E_s =  36;
A = 4;
A_s50 = 0.25;

gamma_max = 0.035;
A_s = 4;
gamma_50 = 5;
lambda = 10^-5;

A_r50 = 5;
E_r = 26.4;

theta = [gamma  rho psi c];
theta_fixe = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r];

std = 2;
control = @(t)([0 0 0]');

mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;
lambda_trial = [5 50 500 5000];

 
 mat_est_oc = zeros(nb_run,length(theta));
 mat_est_nls = zeros(nb_run,length(theta));
 
v_field = @(t,vx,param)vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field = @(t,vx,param)der_vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_theta = @(t,vx,param)der_param_vect_field_bact_fitness(t,vx,param,theta_fixe);
der_v_field_state_theta = @(t,vx,param)der_state_param_vect_bact_fitness(t,vx,param,theta_fixe);
der_v_field_state_state = @(t,vx,param)der_sec_vect_field_bact_fitness(t,vx,param,theta_fixe);

 
 
 for nl = 1 : nb_run
   base_func= @(t)([sin(t) sin(2*t) sin(3*t) sin(4*t)]');
   coeff_c = 20*randn(3,4);
   control_rand = @(t)(coeff_c*base_func(t));  
     
   [T1 Y1] = bacterial_fitness_sim(deb,h_var,fin,theta,theta_fixe,x0,std,control_rand);

   Y_bact = Y1(:,2) + Y1(:,3);
   
    Obs_l = Observation(T1,[Y1(:,1) Y_bact]);
   bs_l = bSplines(Obs_l);
   [est_param_nls,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,mat_obs_c,theta,x0);
   
   [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x0)
	
	mat_est_oc(nl,:) = est_param_opt_data;
	mat_est_nls(nl,:) = est_param_nls;
	
	save('result_temp_bact_fitness',mat_est_oc,mat_est_nls)
 end

 
 %% est param gsa
 
 fn       = @(t,fd_cell,theta)vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);       % RHS function

% Now derivatives of the function with respect to system components and
% parameters

dfdx     = @(t,fd_cell,theta)dx_dvf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);     % Derivative wrt inputs (Jacobian)
dfdp     = @(t,fd_cell,theta)dparam_dvf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);       % Derviative wrt parameters

% Now we need functions to compute all three sets of second derivatives:

d2fdx2   = @(t,fd_cell,theta)d2x_d2vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);  
d2fdxdp  =  @(t,fd_cell,theta)dxdparam_d2vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);  
champ_vect = @(t,vx,param,param_empty)champ_vect_gsa_bacterial_fit_exp(t,vx,param,theta_fixe_sp);


      Tcell = cell(1,3);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);
      Tcell{3} = [];

      Ycell = cell(1,3);
      Ycell{1} = Y1(:,1);
      Ycell{2} =  Y1(:,2) + Y1(:,3);
      Ycell{3} = [];
      


  [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,theta_log_sp,fn, dfdx, dfdp, d2fdx2, d2fdxdp,[],champ_vect);
  [res_est_dc res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,0.7*theta_log_sp,fn, dfdx, dfdp, d2fdx2, d2fdxdp,[],champ_vect);
  
  
  
  %% est discrete version
  
deb=0;
fin=8;
h_var = 0.08;

x0= [0 600 2];

gamma = 2.4*10^-4;
rho = 10^-6;
psi = 0.7;
c = 0.1;


beta = 3;
Pmax = 1.8*10^5;
delta = 6*10^-6;
delta_p = 1.512;
nu_s = 24;
K = 10^9;
E_s =  36;
A = 4;
A_s50 = 0.25;

gamma_max = 0.035;
A_s = 4;
gamma_50 = 5;
lambda = 10^-5;

A_r50 = 5;
E_r = 26.4;

theta = [gamma  rho psi c];
theta_log = [log(theta(1)) log(theta(2)) log(theta(3)) log(theta(4))];
theta_fixe = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r];

theta_sp = [gamma  psi c];
theta_log_sp = [log(theta(1))  log(theta(3)) log(theta(4))];
theta_fixe_sp = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r rho];
  
v_field_exp_sp = @(t,vx,param,pf)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_theta_exp_sp = @(t,vx,param,pf)der_param_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_theta_exp_sp = @(t,vx,param,pf) der_state_param_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_state_exp_sp = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);


    pas = 0.04;
    std = 2;
    
    [T1 Y1] = bacterial_fitness_sim(deb,pas,fin,theta,theta_fixe,x0,std);

   Y_bact = Y1(:,2) + Y1(:,3);
   Obs_l = Observation(T1,[Y1(:,1) Y_bact]);
   bs_l = bSplines(Obs_l);
   
 %%  
   lambda = 10^5;
   mat_U = lambda*eye(3);
   mat_C = zeros(2,3);
   mat_C(1,1) = 1;
   mat_C(2,2) = 1
   mat_C(2,3) = 1
   
   [retain_residual,retain_solution,est_pm1] = compute_discrete_pontryagin_solution(bs_l,mat_C,mat_U,v_field_exp_sp,der_v_field_exp_sp,theta_log_sp,x0,-100*ones(3,1)) 
     