clear

n_pop = 2;
n_bruit = 2;
n_pop_i = 1;
n_bruit_i = 2;

deb=0;
fin=8;
h_var = 0.08;

x0= [0 600 2];

gamma = 2.4*10^-4;
rho = 10^-6;
psi = 0.7;
c = 0.1;


beta = 3;
Pmax = 1.8*10^5;
delta = 6*10^-6;
delta_p = 1.512;
nu_s = 24;
K = 10^9;
E_s =  36;
A = 4;
A_s50 = 0.25;

gamma_max = 0.035;
A_s = 4;
gamma_50 = 5;
lambda = 10^-5;

A_r50 = 5;
E_r = 26.4;

theta = [gamma  rho psi c];
theta_log = [log(theta(1)) log(theta(2)) log(theta(3)) log(theta(4))];
theta_fixe = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r];

theta_sp = [gamma  psi c];
theta_log_sp = [log(theta(1))  log(theta(3)) log(theta(4))];
theta_fixe_sp = [beta Pmax delta delta_p nu_s K E_s A A_s50 gamma_max A_s gamma_50 lambda  A_r50 E_r rho];

control = @(t)([0 0 0]');
 
fn       = @(t,fd_cell,theta)vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);       % RHS function

% Now derivatives of the function with respect to system components and
% parameters

dfdx     = @(t,fd_cell,theta)dx_dvf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);     % Derivative wrt inputs (Jacobian)
dfdp     = @(t,fd_cell,theta)dparam_dvf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);       % Derviative wrt parameters

% Now we need functions to compute all three sets of second derivatives:

d2fdx2   = @(t,fd_cell,theta)d2x_d2vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);  
d2fdxdp  =  @(t,fd_cell,theta)dxdparam_d2vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe_sp);  
champ_vect = @(t,vx,param,param_empty)champ_vect_gsa_bacterial_fit_exp(t,vx,param,theta_fixe_sp);


v_field_exp_sp = @(t,vx,param,pf)vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_exp_sp = @(t,vx,param,pf)der_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_theta_exp_sp = @(t,vx,param,pf)der_param_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_theta_exp_sp = @(t,vx,param,pf) der_state_param_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);
der_v_field_state_state_exp_sp = @(t,vx,param,pf)der_sec_vect_field_bact_fitness_exp_sp(t,vx,param,theta_fixe_sp);


dim_syst = 3;

mat_obs_c = zeros(2,3);
mat_obs_c(1,1) = 1;
mat_obs_c(2,2) = 1;
mat_obs_c(2,3) = 1;

lambda_trial =  [500 1000 5000 10000];
nb_run = 100;




pop_trial = [100 50];
std_trial = [2 3 4 6];

    repertoire = 'estimation_pontryagin_bact_fit_misspe_coeffd1.mat';
    load_res = load(repertoire);     
    
    mat_est_oc_opt_data =  load_res.mat_est_oc_opt_data;  
    mat_est_oc_err_pred2 = load_res.mat_est_oc_err_pred2;  
    mat_est_gsa = load_res.mat_est_gsa;    
    mat_est_nls =  load_res.mat_est_nls;
    mat_est_oc = load_res.mat_est_oc;
    run_ini = load_res.run;
        
    for run = (run_ini+1) : nb_run    
    run

    coeff_dec = 0.01;

    pas = (fin-deb)/pop_trial(n_pop_i);
    std = std_trial(n_bruit_i);
    
    [T1, Y1] = bacterial_fitness_decr_eff_sim(deb,pas,fin,theta,theta_fixe,x0,coeff_dec,std);
    intervalle_int2 = zeros(2,2);
    intervalle_int2(1,:) = [0 T1(25)];
    intervalle_int2(2,:) = [T1(25) T1(50)];
    
   Y_bact = Y1(:,2) + Y1(:,3);
   Obs_l = Observation(T1,[Y1(:,1) Y_bact]);
   bs_l = bSplines(Obs_l);
      
%    knots_temp = [0:0.4:4 6 8];
%    knots_gen{1} = knots_temp;
%    knots_gen{2} = knots_temp;
%    bs_l.setKnots(knots_gen);
%  
      Tcell = cell(1,3);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);
      Tcell{3} = [];

      Ycell = cell(1,3);
      Ycell{1} = Y1(:,1);
      Ycell{2} =  Y1(:,2) + Y1(:,3);
      Ycell{3} = [];
 
    [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,der_v_field_state_theta_exp_sp,der_v_field_state_state_exp_sp,mat_obs_c,lambda_trial,theta_log_sp, x0);


    min_err_pred2 = 10^100;
 
    for nl = 1 : length(lambda_trial)

        mat_U = lambda_trial(nl)*eye(dim_syst);
        bs_u = est_control_pontryagin(bs_l,v_field_exp_sp,der_v_field_exp_sp,mat_obs_c,mat_U,mat_est(nl,:),x0);

        res_err_pred2 = pontryagin_prediction_error_multi_inter(bs_l,bs_u,v_field_exp_sp,mat_obs_c,mat_est(nl,:),x0,intervalle_int2);
      
      if res_err_pred2 < min_err_pred2
          min_err_pred2 = res_err_pred2;
          est_param_oc_err_pred2 = mat_est(nl,:);
          lambda_err_pred2 = lambda_trial(nl);
      end
      
 
    end

     [est_param_nls,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field_exp_sp,der_v_field_exp_sp,der_v_field_theta_exp_sp,mat_obs_c,0.7*theta_log_sp,x0)

     lambda_err_pred2
     est_param_oc_err_pred2
     

     est_param_nls
     
    % try
     [res_est_gsa res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,0.7*theta_log_sp,fn, dfdx, dfdp, d2fdx2, d2fdxdp,[],champ_vect)
     u_gsa = @(t)(evaluate_controle_gsa(t,newDEfd_cell,fn,res_est_gsa));
     res_x0 = max(res_x0,0);
%      catch
%          res_est_gsa = zeros(1,3);
%          res_x0 = zeros(1,3);
%          newDEfd_cell = zeros(1,20);
%          u_gsa = @(t)(0);
%      end
%         


     mat_est_nls(run,1:3) = reshape(est_param_nls(1:3),1,3); 
     mat_est_oc_opt_data(run,1:3) = reshape(est_param_opt_data,1,3);   
  
     mat_est_oc_err_pred2(run,1:3) = reshape(est_param_oc_err_pred2,1,3); 
     mat_est_oc_err_pred2(run,4) = lambda_err_pred2;          
     mat_est_gsa(run,1:3) = reshape(res_est_gsa,1,3);   
     
     for nl = 1 : length(lambda_trial)
         mat_est_oc(run,:,nl) = mat_est(nl,:);
     end
     
   
    save(repertoire,'run','mat_est_oc_opt_data','mat_est_oc_err_pred2','mat_est_nls','mat_est_gsa','mat_est_oc');
    end
   
