function sol = Fitzhugh_Nagumo_nsl_sensitivity_equ(deb,fin,theta)

temp = deb : (fin-deb)/400 :fin;

l_col = length(theta);
l_line = l_col -3;

function dy = equ(t,y_gen)
    y = y_gen(1:l_line);
    y_der = y_gen(l_line+1:l_col*l_line+l_line);
    y_der = reshape(y_der,l_line,l_col);
    
    dy = zeros(l_col*l_line+l_line,1);
    dy(1) = theta(2+1)*(y(1) - ((y(1).^(2+1))/(2+1))+y(2));
    dy(2) = - (1/theta(2+1))*((y(1) - theta(1)) + (theta(2).*y(2))) ;

champ_vect_param = zeros(2,5);
champ_vect_param(1,3) = (y(1) - ((y(1).^(2+1))/(2+1))+y(2));
champ_vect_param(2,1) = 1/theta(3);
champ_vect_param(2,2) = -y(2)/theta(3);
champ_vect_param(2,3) =  (1/(theta(2+1).^2))*((y(1) - theta(1)) + (theta(2).*y(2))) ;

champ_vect_etat = zeros(2,2);
champ_vect_etat(1,1) = theta(3)*(1-y(2).^2);
champ_vect_etat(1,2) = theta(3);
champ_vect_etat(2,1) = -1/theta(3);
champ_vect_etat(2,2) = -theta(2)/theta(3);

y_temp = champ_vect_param + champ_vect_etat*y_der;

y_temp = reshape(y_temp,l_col*l_line,1);

dy(l_line+1:l_col*l_line+l_line) = y_temp;

end

    sol = ode15s(@equ,temp,[theta(4) theta(5) 0 0 0 0 0 0 1 0  0 1]);

end

%plot(T,Y(:,1),'b',T,res(:,1),'bx');
%plot(T,Y(:,1),'b',T,Y(:,2),'r');

