function est_param = est_param_fitz_using_periode(bs,param_ini,nbcond,fonc_test,debut,periode,mat_weight)
    Obs = bs.getObservation();
    T_c = Obs.getTimes();
    Times = T_c{1};
    binf = Times(1);
    bsup = Times(end);
    
    if nargin < 5
        debut =4;
    end
        
    
    if nargin >5
        use_periode = 1;
        nb_weights = nbcond*2+2;
    else
        use_periode = 0;
        nb_weights = nbcond*2;
    end
    
    if nargin < 7
        mat_weight = eye(nb_weights);
    end
    
    function [res res_jacq]= func_eco(param)
        param
        a = param(1);
        b = param(2);
        c = param(3);
        
        function [res_int] = coeff_el_integ(t)
        
        y = bs.calcul_prediction(t,0)';
        vf = zeros(2,1);
        jf = zeros(2,3);
        
        res_t = zeros(2*nbcond,1);
        res_t_der = zeros(2*nbcond,3);
        vf(1) = c*(y(1) - (y(1)^3)/3 + y(2));
        vf(2) = -(1/c)*(y(1) - a + b*y(2));
        
        jf(1,3) = (y(1) - (y(1)^3)/3 + y(2));
        jf(2,1) = 1/c;
        jf(2,2) = -y(2)/c;
        jf(2,3) = (y(1) - a + b*y(2))/(c^2);
        
        %rp =  splines_annulateur_borne(t,binf,bsup,nbcond,0);
        %rp_der = splines_annulateur_borne(t,binf,bsup,nbcond,1); 
          rp = fonc_test(t,binf,bsup,nbcond,0);
          rp_der = fonc_test(t,binf,bsup,nbcond,1);
        
            for nl = 1 : nbcond

                res_t(2*(nl-1)+1:2*nl) = (rp(nl).*vf + y.*rp_der(nl));
                
                res_t_der(2*(nl-1)+1,:) = res_t(2*(nl-1)+1).*(jf(1,:)*rp(nl));
                res_t_der(2*nl,:) = res_t(2*nl).*(jf(2,:)*rp(nl));
            end
            
             res_int = [res_t res_t_der];
        
        end
        

        
        %res = sum(quadv(@coeff_el_integ,binf,bsup).^2)+compute_param_using_periode(bs,param,periode);
        [res_integrale] = quadv(@coeff_el_integ,binf,bsup);
        
        res_integ = res_integrale(:,1);
        res_integ_jacq = res_integrale(:,2:4);
        
        if use_periode ==1

            res_integ = [res_integ'  compute_param_using_periode(bs,param,periode,debut)]';

            res = (res_integ')*mat_weight*res_integ;
        else
            
            res = (res_integ')*mat_weight*res_integ;
        end
        
        res_jacq = 2*sum(res_integ_jacq,1)';

    end
    
    options = optimset('GradObj','off');
    est_param = fminunc(@func_eco,param_ini,options);
end