%%fitz hugh simulation 1rst case
clear

deb=0;
fin=20;
h_var = 0.4;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 0.5;

std = 0.05;

theta = [a b c];
control = @(t)([c*0.15*sin(t) 0]')
 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std,control);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0,control);
 
 [T1_sc Y1_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr_sc Y1_tr_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
 
 
  
 plot(T1_sc,Y1_sc(:,1),'bx',T1_sc,Y1_sc(:,2),'gx',T1_tr_sc,Y1_tr_sc(:,1),'b',T1_tr_sc,Y1_tr_sc(:,2),'g')
 hold on 
 plot(T1,Y1(:,1),'bx',T1,Y1(:,2),'gx',T1_tr,Y1_tr(:,1),'b',T1_tr,Y1_tr(:,2),'g')
 
  Obs_l = Observation(T1,Y1);
   bs_l = bSplines(Obs_l);
%   bs_l.erreur(1);
%   
%   hold on 
%  val_1_x1 = arrayfun(@(t)(1-bs_l.calcul_prediction(t)^2),deb:h_var:fin);
%  plot(deb:h_var:fin,val_1_x1,'r',deb:h_var:fin,(b/(c^2))*ones(length(deb:h_var:fin),1),'g')

%% fitz hugh simulation  2nd  case
clear

deb=0;
fin=20;
h_var = 0.2;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0.1;

theta = [a b c];

 [T1_sc Y1_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr_sc Y1_tr_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
 
  
 plot(T1_sc,Y1_sc(:,1),'bx',T1_sc,Y1_sc(:,2),'gx',T1_tr_sc,Y1_tr_sc(:,1),'b',T1_tr_sc,Y1_tr_sc(:,2),'g')



%% Pontryagin Discretized version: Trial value for eight and lambda 

 mat_C = eye(2);
 Sim_obs = Y1_sc';
% 
% mat_C = [1 0];
% Sim_obs = Y1_sc(:,1)';
% 
mat_B = eye(2);
%lambda = 10000;
%vect_weight = 0.001*ones(length(T1_sc)-1,1);

v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;

val_lambda_trial = [10^-2 0.1 1 10 10^2 10^3 10^4 10^5 10^6 10^7 10^8 10^9 10^10]
val_weight_trial = [10^2 10^1 10^-1 10^-2 10^-3 10^-4 10^-5 10^-6 10^-7 10^-8 10^-9 10^-10 10^-11 10^-12]

mat_val_est = zeros(length(val_lambda_trial),3,length(val_weight_trial));
mat_val_est_dc = zeros(length(val_lambda_trial),3,length(val_weight_trial));

warning off

for nl = 1 : length(val_lambda_trial)
    for nw = 1 :length(val_weight_trial)
        lambda = val_lambda_trial(nl);
        vect_weight = val_weight_trial(nw)*ones(length(mat_C(:,1)),length(T1_sc)-1);
    try
    [est_param,Sval] = param_estimation_pontryagin_discretizedODE(T1_sc,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,theta,x_0,2)
     mat_val_est(nl,:,nw) = est_param;
    catch
        'echec' 
        nl
        nw
    end
    try
    [est_param_dc,Sval] = param_estimation_pontryagin_discretizedODE(T1_sc,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,1.2*theta,x_0,2)
    mat_val_est_dc(nl,:,nw) = est_param_dc;
    catch
       'echec dc' 
        nl
        nw
    end
    
    end
end


%% Pontryagin Discretized version: Trial value for eight and lambda : Constrained Version

 mat_C = eye(2);
 Sim_obs = Y1_sc';
% 
% mat_C = [1 0];
% Sim_obs = Y1_sc(:,1)';
% 
mat_B = eye(2);
%lambda = 10000;
%vect_weight = 0.001*ones(length(T1_sc)-1,1);

v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;

val_lambda_trial = [10^-2 0.1 1 10 10^2 10^3 10^4 10^5 10^6 10^7 10^8 10^9 10^10]
val_weight_trial = [10^2 10^1 10^-1 10^-2 10^-3 10^-4 10^-5 10^-6 10^-7 10^-8 10^-9 10^-10 10^-11 10^-12]

mat_val_est_constrained = zeros(length(val_lambda_trial),3,length(val_weight_trial));
mat_val_est_constrained_dc = zeros(length(val_lambda_trial),3,length(val_weight_trial));

warning off

for nl = 1 : length(val_lambda_trial)
    for nw = 1 :length(val_weight_trial)
        lambda = val_lambda_trial(nl);
        vect_weight = val_weight_trial(nw)*ones(length(mat_C(:,1)),length(T1_sc)-1);
    try
    [est_param,Sval] = param_estimation_pontryagin_discretizedODE_constrained(T1_sc,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,theta,x_0,4,2)
     mat_val_est_constrained(nl,:,nw) = est_param;
    catch
        'echec' 
        nl
        nw
    end
    try
    [est_param_dc,Sval] = param_estimation_pontryagin_discretizedODE_constrained(T1_sc,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,1.2*theta,x_0,4,2)
    mat_val_est_constrained_dc(nl,:,nw) = est_param_dc;
    catch
       'echec dc' 
        nl
        nw;
    end
    
    end
end



%% Pontryagin Discretized version
param_scale = 0.01
mat_C = eye(2);
Sim_obs = Y1_sc'/param_scale;

%mat_C = [1 0];
%Sim_obs = Y1_sc(:,1)'/param_scale;

mat_B = eye(2);
lambda = 10000000;
vect_weight = 1*ones(length(T1_sc)-1,1);


v_field = @(t,vx,param)vect_field_fitzHugh_scaled(t,vx,param, param_scale);
der_v_field = @(t,vx,param)der_vect_field_fitzHugh_scaled(t,vx,param, param_scale);

warning off
%[retain_residual,retain_solution,est_p0] = compute_pontryagin_solution_discretizedODE(T1,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,theta,x0)
[est_param,Sval] = param_estimation_pontryagin_discretizedODE(T1_sc,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,theta,x_0/param_scale,10)

[est_param_dc,Sval] = param_estimation_pontryagin_discretizedODE(T1_sc,Sim_obs,mat_C,mat_B,vect_weight,lambda,v_field,der_v_field,1.5*theta,x_0/param_scale,10)

%%

truefinale_value = Y1_tr(length(T1_tr),:);
mat_obs_c = [0 1];
lambda =(10^15) ;
mat_U = lambda*eye(2);
param_ini = theta;


v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;


% param_trial_plot_2param = [0 2*theta(1); 0.5*theta(2) 1.5*theta(2)];
%  [res_fval1,res_fgrad1] = plot_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state...
%     ,mat_obs_c,mat_U,param_trial_plot_2param,x_0,theta,[1 2]);
% % 
% % 
% [est_param_g_ad_dc,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,theta+0.2,x_0);
% [est_param_g_ad,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,theta,x_0);


%[est_param_g_ad_unknown_ci,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,[theta x_0]);
[est_param_g_ad_dc_unknown_ci,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,[theta x_0]-0.3);
[est_param_g_ad_unknown_ci,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,[theta x_0]+0.1);

 [est_param_nls,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,2,2,[theta x_0],2)
 [est_param_nls_dc,fval_g] =  est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,2,2,[theta x_0]-0.3,2)
 %graph_economic_function_nlsode(Obs1,@champ_fitz_nls,[1 2],param_trial_plot_2param,[a b c],x_0,[2])

%% estimate fitz hugh part obs prem variable
clear

deb=0;
fin=20;
h_var = 0.2;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0;

theta = [a b c];

 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
  
  Obs_l = Observation(T1,Y1(:,1));
  bs_l = bSplines(Obs_l,3);
  bs_l.erreur(1)

mat_obs_c = zeros(1,2);
mat_obs_c(1,1) = 1; 

lambda_trial = [50 100 200 500 1000 10^4 10^6];

v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;

%% PLot economic function
intervalle = [-1 1;-1 1]
intervalle2 = [-0.9 0.9;-0.9 0.9]
figure
paramh= graph_economic_function_nlsode(Obs_l,@(t,vx,param)v_field(t,vx,param,[]),[1 2],intervalle,[0.2 0.2 3],[-1 1],1)
figure
paramh= graph_economic_function_nlsode(Obs_l,@(t,vx,param)v_field(t,vx,param,[]),[1 2],intervalle2,[0.2 0.2 3],[-1 1],1)
%%
 mat_Obs_c = zeros(1,2);
 mat_Obs_c(1,1) = 1; 
% Obs1 = Observation(T1,Y1(:,1));
%  bs_l = bSplines(Obs_l,3);
%        Knots = cell(1,1);    
%      Knots{1} = 0:2/3:20;
%      bs_l.setKnots(Knots);

 param_trial = [-1 1;-1 1]
 param_trial2 = [-0.9 0.9;-0.9 0.9]
 
 figure
 
 try
    [res_fval,res_grad_np] = plot_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,[],[],[],mat_Obs_c,1000*eye(2),param_trial2,[-1 1],[0.2 0.2 3],[1 2],[])
 catch
 end
 
 figure
 
 try
    [res_fval,res_grad_np] = plot_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,[],[],[],mat_Obs_c,10000*eye(2),param_trial2,[-1 1],[0.2 0.2 3],[1 2],[])
 catch
 end
 
 figure
 
  try
    [res_fval,res_grad_np] = plot_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,[],[],[],mat_Obs_c,(10^6)*eye(2),param_trial2,[-1 1],[0.2 0.2 3],[1 2],[])
 catch
  end
 


%%
mat_U = zeros(2);
mat_U(1,1) = 100000;
mat_U(2,2) = 100000000;
[est_param_g_ad_unknown_ci,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,theta,x_0,2);

%%
[est_param_g_ad_unknown_ci,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,theta, x_0,2);
%%
 param_nls = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,2,1,theta, x_0,2)  
 param_nls_dc = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,1,0.8*theta,x_0)  


 [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0,2)


 [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,0.8*theta,x_0,2)


%% estimate fitz hugh part obs deuxime variable
clear

deb=0;
fin=20;
h_var = 0.2;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0.1;

theta = [a b c];
   param_ini_dc = 0.7*theta;
  % param_ini_dc = [0.5 0.5 0.5];

 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
  
  Obs_l = Observation(T1,Y1(:,2));
  bs_l = bSplines(Obs_l,3);
  %bs1.erreur(1);

mat_obs_c = [0 1];

lambda_trial = [5 10:20:90];

v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;

 param_nls = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,2,theta, x_0)  
 param_nls_dc = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,2,param_ini_dc,x_0)  


 [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,param_ini_dc,x_0)


 [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0)

%% estimate fitz hugh fully obsered
clear

deb=0;
fin=20;
h_var = 0.05;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0.1;

theta = [a b c];

 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
  
  Obs_l = Observation(T1,Y1);
  bs_l = bSplines(Obs_l);
  bs_l.erreur(1);

truefinale_value = Y1_tr(length(T1_tr),:);
mat_obs_c = eye(2);
lambda =(10^25) ;
mat_U = lambda*eye(2);
dim_syst = 2;
param_ini = theta;


v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;



 [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,0.9*theta,x_0)



 [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0)

%% test lambda trial fully observed case
clear

deb=0;
fin=20;
h_var = 0.05;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0.1;

theta = [a b c];

 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
  
  Obs_l = Observation(T1,Y1);
  bs_l = bSplines(Obs_l);
  
  Obs1_ps = Observation(T1,Y1(:,1));
  bs_l_ps = bSplines(Obs1_ps);

mat_obs_c_ps = [1 0];
mat_obs_c = eye(2);

lambda_trial = [1 10 100 1000 10^4 10^6]
dim_syst = 2;
param_ini = theta;


v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;

 [est_param_opt_non_param_dc_ps,fval_opt_non_param_dc_ps,lambda_opt_non_param_dc_ps,est_param_opt_data_dc_ps,fval_opt_data_dc_ps,lambda_opt_data_dc_ps, mat_est_dc_ps, mat_fval_dc_ps,est_param_opt_non_param_cor_dc_ps,fval_opt_non_param_cor_dc_ps,lambda_opt_non_param_cor_dc_ps,est_param_opt_data_cor_dc_ps,fval_opt_data_cor_dc_ps,lambda_opt_data_cor_dc_ps]...
    = est_param_pontryagin_lambda_trial(bs_l_ps,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_ps,lambda_trial,0.9*theta,x_0)

 [est_param_opt_non_param_ps,fval_opt_non_param_ps,lambda_opt_non_param_ps,est_param_opt_data_ps,fval_opt_data_ps,lambda_opt_data_ps, mat_est_ps, mat_fval_ps,est_param_opt_non_param_cor_ps,fval_opt_non_param_cor_ps,lambda_opt_non_param_cor_ps,est_param_opt_data_cor_ps,fval_opt_data_cor_ps,lambda_opt_data_cor_ps]...
    = est_param_pontryagin_lambda_trial(bs_l_ps,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_ps,lambda_trial,theta,x_0)


%%
 [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0)

 [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,0.9*theta,x_0)

%% bad specification 1st example sinusoide

deb=0;
fin=20;
h_var = 0.4;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0.1;

theta = [a b c];
control = @(t)([c*0.1*sin(t) 0]')
 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std,control);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0,control);
 
 [T1_sc Y1_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr_sc Y1_tr_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
 

  Obs_l = Observation(T1,Y1);
   bs_l = bSplines(Obs_l);


param_ini = theta;


v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;

dim_syst = 2;
mat_obs_c = eye(dim_syst);
lambda_trial =   [50 100 200 500 1000 10^4 10^6];


 Tcell = cell(1,2);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);

      Ycell = cell(1,2);
      Ycell{1} = Y1(:,1);
      Ycell{2} = Y1(:,2);
 
  param_nls = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,[1 2],theta, x_0)  
  param_nls_dc = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,[1 2],0.8*theta,x_0)  

%  [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,0.8*theta,v_field, der_v_field, der_v_field_theta, der_v_field_state_state , der_v_field_state_theta);
   [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0)

 [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,0.8*theta,x_0)

%% bad specification 2eme example step function

deb=0;
fin=20;
h_var = 0.4;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0.1;
std_dyn = 0.15;

theta = [a b c];

    nb_coeff = 3;
%     res_c_1 = zeros(1,nb_coeff)+std_dyn*randn(nb_coeff,1)'
%     res_c_2 = zeros(1,nb_coeff)+std_dyn*randn(nb_coeff,1)'
%     vect_k_pi = pi*(1:1:nb_coeff);
%     basis_fun_t = @(t)(fonc_base_kar(t,vect_k_pi,deb,fin));            
%     control = @(t)([res_c_1*basis_fun_t(t) res_c_2*basis_fun_t(t)]')

control = @(t)([c*0.15*step_function(t) 0]');
  
 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std,control);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0,control);
 
 [T1_sc Y1_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr_sc Y1_tr_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
  
%  plot(T1_sc,Y1_sc(:,1),'bx',T1_sc,Y1_sc(:,2),'gx',T1_tr_sc,Y1_tr_sc(:,1),'b',T1_tr_sc,Y1_tr_sc(:,2),'g')
%  hold on 
%  plot(T1_tr,Y1_tr(:,1),'b',T1_tr,Y1_tr(:,2),'b',T1_tr_sc,Y1_tr_sc(:,1),'r',T1_tr_sc,Y1_tr_sc(:,2),'r')

  Obs_l = Observation(T1,Y1);
   bs_l = bSplines(Obs_l);
  % bs_l.erreur(1)
 

v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;

fn       = @fhnfun;       % RHS function

% Now derivatives of the function with respect to system components and
% parameters

dfdx     = @fhndfdx;      % Derivative wrt inputs (Jacobian)
dfdp     = @fhndfdp;      % Derviative wrt parameters

% Now we need functions to compute all three sets of second derivatives:

d2fdx2   = @fhnd2fdx2;    % Hessian wrt inputs
d2fdxdp  = @fhnd2fdxdp;   % Hessian wrt inputs and parameters
d2fdp2   = @fhnd2fdp2;    % Hessian wrt parameters.


      Tcell = cell(1,2);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);

      Ycell = cell(1,2);
      Ycell{1} = Y1(:,1);
      Ycell{2} = Y1(:,2);
      


  [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,theta,fn, dfdx, dfdp, d2fdx2, d2fdxdp);
  u_gsa = @(t)(evaluate_controle_gsa(t,newDEfd_cell,fn,res_est));
     
  [err_pred_gsa_wu err_state_gsa_wu] = compute_prediction_error_pontryagin(res_est,theta,400,deb,fin,x_0,x_0,eye(2),v_field,std,[],control)

     
%%     
dim_syst = 2;
mat_obs_c = eye(dim_syst);
%lambda_trial =   [50 100 200 500 1000 10^4 10^6];
lambda_trial =   [5 10:20:80];


 Tcell = cell(1,2);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);

      Ycell = cell(1,2);
      Ycell{1} = Y1(:,1);
      Ycell{2} = Y1(:,2);
      
      param_ini_dc = 0.7*theta;
      param_ini = theta;

      %param_ini_dc = [0.5 0.5 0.5];
 
%   param_nls = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,[1 2],theta, x_0)  
%   param_nls_dc = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,[],2,[1 2],param_ini_dc,x_0)  
% 
%   [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,param_ini_dc ,fn, dfdx, dfdp, d2fdx2 , d2fdxdp);
%    [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
%     = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0)
% 
%  [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
%     = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,param_ini_dc,x_0)


%%

lambda_trial = [50 100 200 500 1000 10^4 10^6];

mat_obs_c = zeros(1,2);
mat_obs_c(1,1) = 1; 

tic
%  [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,0.8*theta,v_field, der_v_field, der_v_field_theta, der_v_field_state_state , der_v_field_state_theta);
   [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,theta,x_0,2)

toc2  = toc;

tic
 [est_param_opt_non_param_dc,fval_opt_non_param_dc,lambda_opt_non_param_dc,est_param_opt_data_dc,fval_opt_data_dc,lambda_opt_data_dc, mat_est_dc, mat_fval_dc,est_param_opt_non_param_cor_dc,fval_opt_non_param_cor_dc,lambda_opt_non_param_cor_dc,est_param_opt_data_cor_dc,fval_opt_data_cor_dc,lambda_opt_data_cor_dc]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,0.7*theta,x_0,2)

toc2_dec = toc;


%%

clear

deb=0;
fin=20;
h_var = 0.04;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 0.2;

std = 0;

theta = [a b c];

 [T1_tr_sc Y1_tr_sc] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 
 
  
 plot(T1_tr_sc,Y1_tr_sc(:,1),'b',T1_tr_sc,Y1_tr_sc(:,2),'g')
 
   Obs_l = Observation(T1_tr_sc,Y1_tr_sc);
   bs_l = bSplines(Obs_l);
   
   
%%

lambda = 10^20;
mat_U = lambda*eye(2);
mat_C = eye(2);
v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;


[param_est,Sval] = param_estimation_discrete_pontryagin(bs_l,mat_C,lambda,v_field,der_v_field,theta,x_0) 