%% Initalisation param

deb=0;
fin=20;
h = 0.05;

x0= [-1 1];
a = 0.2;
b = 0.2;
c = 2+1;
std = 0.2;

theta = [a b c];
theta0=[1 1 2];
theta_etendu = [a b c 1];

[T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);

intervalle = zeros(2);
 intervalle(1,:) = [0.5 1.5];
intervalle(2,:) = [-0.5 0];

nb_test=100;

gm_matrice_1 = zeros(nb_test,2+1);
oc_matrice_1 = zeros(nb_test,2+1);
oc_matrice_1_min = zeros(nb_test,2+1);

var_oc_matrice_1 = zeros(nb_test,2+1);
var_oc_matrice_1_min = zeros(nb_test,2+1);

nls_matrice_1 = zeros(nb_test,5);

time_gm_matrice_1 = zeros(nb_test,1);
time_oc_matrice_1 = zeros(nb_test,1);
time_oc_matrice_1_min = zeros(nb_test,1);
time_nls_matrice_1 = zeros(nb_test,1);

gm_matrice_2 = zeros(nb_test,2+1);
oc_matrice_2 = zeros(nb_test,2+1);
nls_matrice_2 = zeros(nb_test,5);

time_gm_matrice_2 = zeros(nb_test,1);
time_oc_matrice_2 = zeros(nb_test,1);
time_nls_matrice_2 = zeros(nb_test,1);

%% Test estimation via period

deb=0;
fin=20;
h = 0.1;

x0= [-1 1];
a = 0.2;
b = 0.2;
c = 2+1;
std = 0.4;

theta = [a b c];
theta0=[1 1 2];
theta_etendu = [a b c 1];
nbcond = 6;

nb_bruit_max = 2;
nb_pop_max = 2;
nb_test_max= 100;
[est_periode fun_eco] = est_periode_fitz(sol,[a b c],8);

C_res = cell(nb_pop_max,nb_bruit_max);
C_res_periode = cell(nb_pop_max,nb_bruit_max);

for nb_bruit = 1 : nb_bruit_max
    for nb_pop = 1 : nb_pop_max
        
        res_param = zeros(nb_test_max,3);
        res_param_ci = zeros(nb_test_max,3);
        
        for nb_test = 1 : nb_test_max
            nb_test

        [T1 Y1] = fitz_nagumo(deb,fin,h*nb_pop,x0,a,b,c,0.15*nb_bruit);
        sol = fitz_nagumo(deb,fin,h,x0,a,b,c,0);

         Obs1 = Observation(T1,Y1);
         bs1 = bSplines(Obs1);

         est_param = est_param_fitz_using_periode(bs1,[1 1 2],nbcond,@phi,@phi_der);
         est_param_periode = est_param_fitz_using_periode(bs1,[1 1 2],nbcond,@phi,@phi_der,est_periode);

         res_param(nb_test,:) = est_param;
         res_param_ci(nb_test,:) = est_param_periode;

        end
    end
end

% est_param = compute_param_using_periode(bs1,[a b c],est_periode)
% est_param = compute_param_using_periode(bs1,[1 1 2],est_periode)
% est_param = compute_param_using_periode(bs1,[1 1 2]+ randn(3,1)',est_periode)

%Obs1 = Observation(T1,Y1);
%kr1 = Polynomes_locaux(Obs1,@gaussien)

%Obs2 = Observation(T1,Y1(:,1));
%kr2 = Polynomes_locaux(Obs2,@gaussien)

%% Compare different criteria for L selection

nb_test_nb_oc = 15;
 val_param_oc1_opt = zeros(nb_test_nb_oc,2+1);
 val_param_oc1_direct = zeros(nb_test_nb_oc,2+1);
 val_param_oc1_derivee = zeros(nb_test_nb_oc,2+1);
 val_param_oc1_gm = zeros(nb_test_nb_oc,2+1);
 
  val_param_gm = zeros(nb_test_nb_oc,2+1);
 
 distance_oc1_opt = zeros(nb_test_nb_oc,2+1);
 distance_oc1_direct= zeros(nb_test_nb_oc,2+1);
 distance_oc1_derivee = zeros(nb_test_nb_oc,2+1);
 distance_oc1_gm = zeros(nb_test_nb_oc,2+1);
 
 distance_gm = zeros(nb_test_nb_oc,2+1);
 
 nb_cond_opt = zeros(nb_test_nb_oc,1);
 nb_cond_direct = zeros(nb_test_nb_oc,1);
 nb_cond_derivee = zeros(nb_test_nb_oc,1);
 nb_cond_gm = zeros(nb_test_nb_oc,1);

for ntno = 1 : nb_test_nb_oc
ntno
 [T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);
 Obs1 = Observation(T1,Y1);
 bs1 = bSplines(Obs1);

% Compare with gradient matching result
gm_linearode1 = Gradient_matching(bs1,@poids,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],[]);
[param_gm1 t_est_gm1] = gm_linearode1.estimation_parametre(theta0);

 ecart_rel_direct = 1000000000;
 ecart_rel_derivee = 100000000;
 ecart_rel_gm = 10000000000;
 ecart_relatif = 100000000;
 
for nb_condi = 2+1 : 50
    oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],[],nb_condi);
    [param_oc1 t_est_oc1] = oc_linearode1.estimation_parametre(theta0);

    ecart_relatif_temp = (param_oc1 - theta)./theta;
    
    if sum(ecart_relatif_temp.^2) < ecart_relatif
        ecart_relatif = sum(ecart_relatif_temp.^2);
        val_param_oc = param_oc1;
        nb_cond_opt(ntno) = nb_condi;
    end
    

    [temp_pred val_pred] = fitz_nagumo(deb,fin,h,x0,param_oc1(1),param_oc1(2),param_oc1(2+1),0);
    ecart_rel_direct_temp = sum(sum((Y1 - val_pred).^2));

    ecart_rel_derivee_temp = sum(sum(quadv(@(t)func_critere_der(t,oc_linearode1,param_oc1),0,5)));
    ecart_rel_gm_temp = sum(sum(quadv(@(t)func_critere_gm(t,oc_linearode1,param_oc1),0,5)));
    
    if ecart_rel_direct_temp < ecart_rel_direct
        ecart_rel_direct = ecart_rel_direct_temp;
        val_param_oc_direct = param_oc1;
        nb_cond_direct(ntno) = nb_condi;
    end
    
    if ecart_rel_derivee_temp < ecart_rel_derivee
        ecart_rel_derivee = ecart_rel_derivee_temp;
        val_param_oc_derivee = param_oc1;
        nb_cond_derivee(ntno) = nb_condi;
    end
    
    if ecart_rel_gm_temp < ecart_rel_gm
        ecart_rel_gm = ecart_rel_gm_temp;
        val_param_oc_gm = param_oc1;
        nb_cond_gm(ntno) = nb_condi;
    end

end

val_param_oc1_opt(ntno,:) = val_param_oc;
val_param_oc1_direct(ntno,:) = val_param_oc_direct;
val_param_oc1_derivee(ntno,:) = val_param_oc_derivee;
val_param_oc1_gm(ntno,:) = val_param_oc_gm;
val_param_gm(ntno,:) = param_gm1;

distance_oc1_opt(ntno,:) = (val_param_oc - theta)./theta;
distance_oc1_direct(ntno,:) = (val_param_oc_direct - theta)./theta;
distance_oc1_derivee(ntno,:) = (val_param_oc_derivee - theta)./theta;
distance_oc1_gm(ntno,:) = (val_param_oc_gm - theta)./theta;

distance_gm(ntno,:) = (param_gm1 - theta)./theta;

end

%% Compute estimator & sensistivity equation

 [T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);
 Obs1 = Observation(T1,Y1);
%  fr1 = Fourier_regression(Obs1);
%  fr1.calcul_prediction([6 8],0)
%  fr1.calcul_prediction([6 8],1)
%  fr1.erreur(1)

    %bs1 = bSplines(Obs1,3,[-1,1]);

    %bs1.getValeurVariance(1,2)
 
%  gm_linearode1 = Gradient_matching(bs1,@poids,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,@fitz_nagumo_exacte,[]);
%  [param_gm1 t_est_gm1] = gm_linearode1.estimation_parametre(theta0);
%  gm_linearode1.estimation_C_I()

 %var_homoscedastique = bs1.getValeurVariance(1,1)
 %var_heteroscedastique = diag(bs1.getValeurVariance(1,2))
  %oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,@fitz_nagumo_exacte,@derivee_variable_fitz_nagumo,6);
 %[param_oc1 t_est_oc1] = oc_linearode1.estimation_parametre(theta0)
 
 % var_homoscedastique = calcul_variance_parametre(oc_linearode1,1)
 % var_heteroscedastique = calcul_variance_parametre(oc_linearode1,2)
 %res1 =  oc_linearode1.compute_sensitivity_equ();
 %oc_linearode1.minimize_variance(theta0)
 %oc_linearode1.estimation_C_I()
 
 %%
 
 for ni = 1 : 10
 theta_etendu_rand = theta_etendu + 0.4*randn(4,1)'
 %[res_jac res_rank] = compute_rank_fitzHugh(bs1,theta_etendu_rand,@splines_annulateur_borne,6);
  %param_estimator = compute_param_fitzHugh_direct(bs1,theta_etendu_rand,@splines_annulateur_borne,6);
  param_estimator_gradient = compute_param_fitzHugh_direct(bs1,theta_etendu_rand,@splines_annulateur_borne,6,'on');
 
  param_estimator
  param_estimator_gradient
  
 res_rank
 end
 
 
 %%
deb=0;
fin=20;
h = 0.05;

x0= [-1 1];
a = 0.2;
b = 0.2;
c = 2+1;
std = 0.15;
 

est_param_tot_obs = zeros(100,3);
var_param_tot_obs = zeros(100,3);

est_param_part_obs = zeros(100,3);
var_param_part_obs = zeros(100,3);

for ni =1 :100
    
 [T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);
 Obs1_part = Observation(T1,Y1(:,1));
 bs1_part = bSplines(Obs1_part);
 
 Obs1 =  Observation(T1,Y1);
 bs1 = bSplines(Obs1);
 
 oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,@fitz_nagumo_exacte,@derivee_variable_fitz_nagumo,6);
 [param_oc1 t_est_oc1] = minimize_variance(oc_linearode1,[1 1 2],0.000000001,25);
 est_param_tot_obs(ni,:) = param_oc1;

  matrice_variance_oc = oc_linearode1.calcul_variance_parametre();
  var_param_tot_obs(ni,:) = diag(matrice_variance_oc)'; 

  
 [est_param est_variance interval_confiance] = minimize_variance_fitzHugh(bs1_part,@splines_annulateur_borne,6,[1 1 2])
 
 est_param_part_obs(ni,:) = est_param;
 var_param_part_obs(ni,:) = diag(est_variance);
 
end
%% Difference between direct and weighted direct criteria

nb_test_nb_oc = 15;
 val_param_oc1_opt = zeros(nb_test_nb_oc,2+1);
 val_param_oc1_direct = zeros(nb_test_nb_oc,2+1);
 val_param_oc1_direct_ponderee = zeros(nb_test_nb_oc,2+1);
 
  val_param_gm = zeros(nb_test_nb_oc,2+1);
 
 distance_oc1_opt = zeros(nb_test_nb_oc,2+1);
 distance_oc1_direct= zeros(nb_test_nb_oc,2+1);
 distance_oc1_direct_ponderee = zeros(nb_test_nb_oc,2+1);
 
 distance_gm = zeros(nb_test_nb_oc,2+1);
 
 nb_cond_opt = zeros(nb_test_nb_oc,1);
 nb_cond_direct = zeros(nb_test_nb_oc,1);
 nb_cond_direct_ponderee = zeros(nb_test_nb_oc,1);

for ntno = 1 : nb_test_nb_oc
ntno

 matrice_param_est = zeros(50-4+1,2+1);
 [T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);
 Obs1 = Observation(T1,Y1);
 bs1 = bSplines(Obs1);

% Compare with gradient matching result
gm_linearode1 = Gradient_matching(bs1,@poids,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],[]);
[param_gm1 t_est_gm1] = gm_linearode1.estimation_parametre(theta0);

 ecart_rel_direct = 1000000000;
 ecart_rel_gm = 10000000000;
 ecart_relatif = 100000000;
 
for nb_condi = 2+1 : 50
    oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],@derivee_variable_fitz_nagumo,nb_condi);
    [param_oc1 t_est_oc1] = oc_linearode1.estimation_parametre(theta0);
    matrice_param_est(nb_condi - 2,:) = param_oc1; 

    ecart_relatif_temp = (param_oc1 - theta)./theta;
    
    if sum(ecart_relatif_temp.^2) < ecart_relatif
        ecart_relatif = sum(ecart_relatif_temp.^2);
        val_param_oc = param_oc1;
        nb_cond_opt(ntno) = nb_condi;
    end
    

    [temp_pred val_pred] = fitz_nagumo(deb,fin,h,x0,param_oc1(1),param_oc1(2),param_oc1(2+1),0);
    ecart_rel_direct_temp = sum(sum((Y1 - val_pred).^2));

    ecart_rel_derivee_temp = sum(sum(quadv(@(t)func_critere_der(t,oc_linearode1,param_oc1),0,5)));
    ecart_rel_gm_temp = sum(sum(quadv(@(t)func_critere_gm(t,oc_linearode1,param_oc1),0,5)));
    
    if ecart_rel_direct_temp < ecart_rel_direct
        ecart_rel_direct = ecart_rel_direct_temp;
        val_param_oc_direct = param_oc1;
        nb_cond_direct(ntno) = nb_condi;
    end


end

a_moy = stats(matrice_param_est(:,1),0.2);
b_moy = stats(matrice_param_est(:,2),0.2);
c_moy = stats(matrice_param_est(:,2+1),2+1);
[time_sens res_sens] = oc_linearode1.compute_sensitivity_equ([a_moy b_moy c_moy]);

res_sens = res_sens.^2;

sum_a_v = sum(res_sens(:,1));
sum_b_v = sum(res_sens(:,2));
sum_c_v = sum(res_sens(:,2+1));

sum_a_r = sum(res_sens(:,4));
sum_b_r = sum(res_sens(:,5));
sum_c_r = sum(res_sens(:,6));

ecart_rel_direct_ponderee = 1000000000000000000;

for nv_cond = 2+1 : 50
    a_val = matrice_param_est(nv_cond-2,1);
    b_val = matrice_param_est(nv_cond-2,2);
    c_val = matrice_param_est(nv_cond-2,2+1);
    [temp_pred val_pred] =  fitz_nagumo(deb,fin,h,x0,a_val,b_val,c_val,0);
    [nv_time_sens nv_res_sens] = oc_linearode1.compute_sensitivity_equ([a_val b_val c_val]);
    nv_res_sens = nv_res_sens.^2;
    
    Ypond = zeros(length(nv_res_sens(:,1)),2);
    val_pond = zeros(length(nv_res_sens(:,1)),2);
    
    Ypond(:,1) = (((sum_c_v+ sum_b_v)*nv_res_sens(:,1))/sum_a_v + ((sum_c_v+ sum_a_v)*nv_res_sens(:,2))/sum_b_v + ((sum_b_v+ sum_a_v)*nv_res_sens(:,2+1))/sum_c_v).*Y1(:,1);
    val_pond(:,1) = (((sum_c_v+ sum_b_v)*nv_res_sens(:,1))/sum_a_v + ((sum_c_v+ sum_a_v)*nv_res_sens(:,2))/sum_b_v + ((sum_b_v+ sum_a_v)*nv_res_sens(:,2+1))/sum_c_v).*val_pred(:,1);
    
    Ypond(:,2) = (((sum_c_r+ sum_b_r)*nv_res_sens(:,4))/sum_a_r + ((sum_c_r+ sum_a_r)*nv_res_sens(:,5))/sum_b_r + ((sum_b_r+ sum_a_r)*nv_res_sens(:,6))/sum_c_r).*Y1(:,2);
    val_pond(:,2) = (((sum_c_r+ sum_b_r)*nv_res_sens(:,4))/sum_a_r + ((sum_c_r+ sum_a_r)*nv_res_sens(:,5))/sum_b_r + ((sum_b_r+ sum_a_r)*nv_res_sens(:,6))/sum_c_r).*val_pred(:,2);
    
    ecart_rel_direct_temp_ponderee = sum(sum((Ypond - val_pond).^2));
    
    if ecart_rel_direct_temp_ponderee < ecart_rel_direct_ponderee
         ecart_rel_direct_ponderee = ecart_rel_direct_temp_ponderee;
         val_param_oc_direct_ponderee = matrice_param_est(nv_cond-2,:);
         nb_cond_direct_ponderee(ntno) = nv_cond;
     end
    
end



val_param_oc1_opt(ntno,:) = val_param_oc;
val_param_oc1_direct(ntno,:) = val_param_oc_direct;
val_param_oc1_direct_ponderee(ntno,:) = val_param_oc_direct_ponderee;
val_param_gm(ntno,:) = param_gm1;

distance_oc1_opt(ntno,:) = (val_param_oc - theta)./theta;
distance_oc1_direct(ntno,:) = (val_param_oc_direct - theta)./theta;
distance_oc1_direct_ponderee(ntno,:) = (val_param_oc_direct_ponderee - theta)./theta;

distance_gm(ntno,:) = (param_gm1 - theta)./theta;

end

%% Eigenvalue criteria for L selection
nb_test_nb_oc = 15;

matrice_estimation = zeros(nb_test_nb_oc,2+1);
nb_cond_sel = zeros(nb_test_nb_oc,1);
for ntno = 1 : nb_test_nb_oc
ntno
 [T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);
 Obs1 = Observation(T1,Y1);
 bs1 = bSplines(Obs1);

 ecart_relatif = 100000000000000;
 
 matrice_param_est = zeros(50-2,2+1);
 somme1 = 0;
 rapport_somme = 1;
 valeur_ecart = zeros(50-2,1);
 
 for nb_condi =2+1 : 50
     
   oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],@derivee_variable_fitz_nagumo,nb_condi);
    [param_oc1 t_est_oc1] = oc_linearode1.estimation_parametre(theta0);
    
    ecart_relatif = (param_oc1 - theta)./theta;
    valeur_ecart(nb_condi-2) = sum(ecart_relatif.^2);
 
if rapport_somme > 0.01
    mat_variance = oc_linearode1.calcul_variance_coeff_proj();
    
    [Um,Vm] = eig(mat_variance);    
    valeur_propre = diag(Vm)';
    
    somme = sum(valeur_propre);
    difference_somme = (somme - somme1);
    
    rapport_somme = difference_somme/somme;
    somme1 = somme;
    nb_cond_sel(ntno) = nb_condi;
    matrice_estimation(ntno,:) = param_oc1;
else
    rapport_somme = 0;
end
    
 end

 plot(2+1:50,valeur_ecart,'rx')
 figure

end
 
%% test variance variation and interval estimation
nb_run = 15;

st_var = 0;
C_gm = cell(nb_run,1);
C_oc = cell(nb_run,1);

C_oc_a = cell(nb_run,1);
C_oc_b = cell(nb_run,1);
C_oc_c = cell(nb_run,1);

for ocur = 1 : nb_run
    
    st_var = st_var + 0.05;
    matrice_run_gm = zeros(100,2+1);
    matrice_run_oc = zeros(100,2+1);
    
    matrice_run_oc_a = zeros(100,2);
    matrice_run_oc_b = zeros(100,2);
    matrice_run_oc_c = zeros(100,2);
    
    
    for run =  1 : 100
    
  [T1 Y1] = fitz_nagumo(deb,fin,h,x0,a,b,c,std);
  Obs1 = Observation(T1,Y1);
  bs1 = bSplines(Obs1);

 gm_linearode1 = Gradient_matching(bs1,@poids,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],[]);
 [param_gm1 t_est_gm1] = gm_linearode1.estimation_parametre(theta0);
 
 matrice_run_gm(run,:) = param_gm1;
 
   oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,[],@derivee_variable_fitz_nagumo,6);

 [param_oc1 t_est_oc1] = minimize_variance(oc_linearode1,theta0);
 matrice_run_oc(run,:) = param_oc1;
 
 cs_a_b_c = oc_linearode1.parameter_confidence_set([1 2 2+1]);
 matrice_run_oc_a(run,:)  = cs_a_b_c(1,:);
 matrice_run_oc_b(run,:)  = cs_a_b_c(2,:);
 matrice_run_oc_c(run,:)  = cs_a_b_c(2+1,:);
 
    end
    C_gm{ocur} = matrice_run_gm;
    C_oc{ocur} = matrice_run_oc;
    
    C_oc_a{ocur} = matrice_run_oc_a;
    C_oc_b{ocur} = matrice_run_oc_b;
    C_oc_c{ocur} = matrice_run_oc_c;
    
end

mat_gm_a = zeros(100,nb_run);
mat_gm_b = zeros(100,nb_run);
mat_gm_c = zeros(100,nb_run);

mat_oc_a = zeros(100,nb_run);
mat_oc_b = zeros(100,nb_run);
mat_oc_c = zeros(100,nb_run);

mat_gm_a_dist = zeros(100,nb_run);
mat_gm_b_dist = zeros(100,nb_run);
mat_gm_c_dist = zeros(100,nb_run);


mat_oc_a_dist = zeros(100,nb_run);
mat_oc_b_dist = zeros(100,nb_run);
mat_oc_c_dist = zeros(100,nb_run);


for nb_mat = 1 : nb_run
occurence = nb_mat
    val_moy_a_inf = stats(C_oc_a{nb_mat}(:,1),0.2)
    val_moy_a_sup = stats(C_oc_a{nb_mat}(:,2),0.2)
    
    val_moy_b_inf = stats(C_oc_b{nb_mat}(:,1),0.2)
    val_moy_b_sup = stats(C_oc_b{nb_mat}(:,2),0.2)
    
    val_moy_c_inf = stats(C_oc_c{nb_mat}(:,1),2+1)
    val_moy_c_sup = stats(C_oc_c{nb_mat}(:,2),2+1)
    
mat_gm_a(:,nb_mat) = C_gm{nb_mat}(:,1);
mat_gm_b(:,nb_mat) = C_gm{nb_mat}(:,2);
mat_gm_c(:,nb_mat) = C_gm{nb_mat}(:,2+1);

mat_gm_a_dist(:,nb_mat) = (0.2-C_gm{nb_mat}(:,1)).^2;
mat_gm_b_dist(:,nb_mat) = (0.2-C_gm{nb_mat}(:,2)).^2;
mat_gm_c_dist(:,nb_mat) = ((2+1)-C_gm{nb_mat}(:,2+1)).^2;

mat_oc_a(:,nb_mat) = C_oc{nb_mat}(:,1);
mat_oc_b(:,nb_mat) = C_oc{nb_mat}(:,2);
mat_oc_c(:,nb_mat) = C_oc{nb_mat}(:,2+1);

mat_oc_a_dist(:,nb_mat) = (0.2-C_oc{nb_mat}(:,1)).^2;
mat_oc_b_dist(:,nb_mat) = (0.2-C_oc{nb_mat}(:,2)).^2;
mat_oc_c_dist(:,nb_mat) = ((2+1)-C_oc{nb_mat}(:,2+1)).^2;

end
 
boxplot(mat_gm_a,'color','b');
hold on
boxplot(mat_oc_a,'color','r');

figure

boxplot(mat_gm_b,'color','b');
hold on
boxplot(mat_oc_b,'color','r');

figure

boxplot(mat_gm_c,'color','b');
hold on
boxplot(mat_oc_c,'color','r');

figure

boxplot(mat_gm_a_dist,'color','b');
hold on
boxplot(mat_oc_a_dist,'color','r');

figure

boxplot(mat_gm_b_dist,'color','b');
hold on
boxplot(mat_oc_b_dist,'color','r');

figure

boxplot(mat_gm_c_dist,'color','b');
hold on
boxplot(mat_oc_c_dist,'color','r');



%% test variance variation and interval estimation for different population number
nb_run = 2;
nb_pop = 3;
deb=0;
fin=20;
h_var = 0.05;

x0= [-1 1];
a = 0.2;
b = 0.2;
c = 2+1;

theta = [a b c];
theta0=[1 1 2];

C_gm = cell(nb_run,nb_pop);
C_oc_non_min = cell(nb_run,nb_pop);
C_oc_var_non_min = cell(nb_run,nb_pop);
C_oc = cell(nb_run,nb_pop);
C_oc_var = cell(nb_run,nb_pop);
C_gm_ci = cell(nb_run,nb_pop);
C_oc_ci_non_min = cell(nb_run,nb_pop);
C_oc_ci = cell(nb_run,nb_pop);

C_nls = cell(nb_run,nb_pop);
C_nls_var = cell(nb_run,nb_pop);

C_oc_a = cell(nb_run,nb_pop);
C_oc_b = cell(nb_run,nb_pop);
C_oc_c = cell(nb_run,nb_pop);

C_oc_a_non_min = cell(nb_run,nb_pop);
C_oc_b_non_min = cell(nb_run,nb_pop);
C_oc_c_non_min = cell(nb_run,nb_pop);


C_nls_a = cell(nb_run,nb_pop);
C_nls_b = cell(nb_run,nb_pop);
C_nls_c = cell(nb_run,nb_pop);

C_nls_impr = cell(nb_run,nb_pop);
C_nls_var_impr = cell(nb_run,nb_pop);
C_nls_a_impr = cell(nb_run,nb_pop);
C_nls_b_impr = cell(nb_run,nb_pop);
C_nls_c_impr = cell(nb_run,nb_pop);

C_gm_t = cell(nb_run,nb_pop);
C_oc_t = cell(nb_run,nb_pop);
C_oc_non_min_t = cell(nb_run,nb_pop);
C_nls_t = cell(nb_run,nb_pop);
C_nls_t_impr = cell(nb_run,nb_pop);



for nb_obs = 1 : nb_pop
    h_var = h_var*2^(nb_obs-1);
    st_var = 0.075;

for ocur = 1 : nb_run
    ocur
    
    st_var = 2*st_var;
    matrice_run_gm = zeros(100,2+1);
	matrice_run_gm_ci = zeros(100,2);
    
    matrice_run_oc = zeros(100,2+1);
    matrice_run_oc_var = zeros(100,2+1);
	matrice_run_oc_ci = zeros(100,2);
    
    matrice_run_oc_non_min = zeros(100,2+1);
    matrice_run_oc_var_non_min = zeros(100,2+1);
	matrice_run_oc_ci_non_min = zeros(100,2);
    
	matrice_run_nls = zeros(100,5);
    matrice_run_nls_var = zeros(100,3);
    
    matrice_run_oc_a = zeros(100,2);
    matrice_run_oc_b = zeros(100,2);
    matrice_run_oc_c = zeros(100,2);
    
    matrice_run_oc_a_non_min = zeros(100,2);
    matrice_run_oc_b_non_min = zeros(100,2);
    matrice_run_oc_c_non_min = zeros(100,2);
    
    matrice_run_nls_a = zeros(100,2);
    matrice_run_nls_b = zeros(100,2);
    matrice_run_nls_c = zeros(100,2);
    
    matrice_run_gm_t = zeros(100,1);
    matrice_run_oc_t = zeros(100,1);
    matrice_run_oc_non_min_t = zeros(100,1);
    matrice_run_nls_t = zeros(100,1);
    matrice_run_nls_t_impr = zeros(100,1);
    
    matrice_run_nls_impr = zeros(100,5);
    matrice_run_nls_var_impr = zeros(100,3);
    matrice_run_nls_a_impr = zeros(100,2);
    matrice_run_nls_b_impr = zeros(100,2);
    matrice_run_nls_c_impr = zeros(100,2);
    
    for run =  1 : 100
    run
        
  [T1 Y1] = fitz_nagumo(deb,fin,h_var,x0,a,b,c,st_var);
  Obs1 = Observation(T1,Y1);
  bs1 = bSplines(Obs1);

 gm_linearode1 = Gradient_matching(bs1,@poids,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,@fitz_nagumo_exacte);
 [param_gm1 t_est_gm1] = gm_linearode1.estimation_parametre(theta0);

 matrice_run_gm_t(run,:) = t_est_gm1;
 matrice_run_gm(run,:) = param_gm1;
% matrice_run_gm_ci(run,:) = gm_linearode1.estimation_C_I();
 try
  matrice_run_gm_ci(run,:) = gm_linearode1.estimation_C_I();
  catch err
  matrice_run_gm_ci(run,:) = [10 10];    
  end;

    %oc

    nv_nbcond = 7;
    convergence = 0;
   while convergence == 0
   %oc non min
   nv_nbcond = nv_nbcond -1;
   oc_linearode1 = Orthogonal_condition(bs1,@phi,@phi_der,@modele_fitz,@jacobien_fitz_nagumo,@hessien_fitz_nagumo,@fitz_nagumo_exacte,@derivee_variable_fitz_nagumo,nv_nbcond);
   [param_oc1_non_min t_est_oc1] = oc_linearode1.estimation_parametre(theta0);
   
   matrice_run_oc_non_min(run,:) = param_oc1_non_min;
   matrice_run_oc_non_min_t(run,:) = t_est_oc1;
   matrice_run_oc_ci_non_min(run,:) = oc_linearode1.estimation_C_I();
   matrice_variance_oc_non_min =  oc_linearode1.calcul_variance_parametre();
   matrice_run_oc_var_non_min(run,:) = diag(matrice_variance_oc_non_min)'; 
  
   cs_a_b_c_non_min = oc_linearode1.parameter_confidence_set();
   matrice_run_oc_a_non_min(run,:)  = cs_a_b_c_non_min (1,:);
   matrice_run_oc_b_non_min(run,:)  = cs_a_b_c_non_min (2,:);
   matrice_run_oc_c_non_min(run,:)  = cs_a_b_c_non_min (2+1,:);
   
  %oc min  
  [param_oc1 t_est_oc1] = minimize_variance(oc_linearode1,theta0,0.000000001,25);
  matrice_run_oc_t(run,:) = t_est_oc1;
  matrice_run_oc(run,:) = param_oc1;
  matrice_variance_oc = oc_linearode1.calcul_variance_parametre();
  matrice_run_oc_var(run,:) = diag(matrice_variance_oc)'; 
  matrice_run_oc_ci(run,:) = oc_linearode1.estimation_C_I();
  
  cs_a_b_c = oc_linearode1.parameter_confidence_set();
  matrice_run_oc_a(run,:)  = cs_a_b_c(1,:);
  matrice_run_oc_b(run,:)  = cs_a_b_c(2,:);
  matrice_run_oc_c(run,:)  = cs_a_b_c(2+1,:);
 
 
% matrice_run_oc_ci(run,:) = oc_linearode1.estimation_C_I();
  try
 matrice_run_oc_ci(run,:) = oc_linearode1.estimation_C_I();
  catch err
  matrice_run_oc_ci(run,:) = [10 10];
  end

if sum(abs(param_oc1)) == 3
    convergence = 0;
else
    convergence = 1;
end
    end
%nls
%[paramh1,resnorm,residual,Covb,t_est_nls1]=nv_nlsode(Obs1,@champ_fitz_nls,theta0,x0);
 try
 [paramh1,resnorm,residual,Covb,t_est_nls1]=nv_nlsode(Obs1,@champ_fitz_nls,theta0,Y1(1,:));
 catch err
     paramh1 = [10 10 10 10 10];
     Covb = eye(5);
     t_est_nls1 = 0;
 end
 matrice_run_nls(run,:) = paramh1;
 matrice_run_nls_t(run,:) = t_est_nls1;

  matrice_variance_nls = diag(Covb)'; 
  matrice_run_nls_var(run,:) = matrice_variance_nls(1:3);
  

 nls_a_b_c  =intervalle_confiance_nls(matrice_variance_nls(1:3),paramh1(1:3),0.05);
 matrice_run_nls_a(run,:)  = nls_a_b_c(1,:);
 matrice_run_nls_b(run,:)  = nls_a_b_c(2,:);
 matrice_run_nls_c(run,:)  = nls_a_b_c(2+1,:);
 
%improved nls
%[paramh1,resnorm,residual,Covb,t_est_nls1]=nv_nlsode(Obs1,@champ_fitz_nls,matrice_run_oc(run,:),matrice_run_oc_ci(run,:));
 try
 [paramh1,resnorm,residual,Covb,t_est_nls1]=nv_nlsode(Obs1,@champ_fitz_nls,matrice_run_oc(run,:),matrice_run_oc_ci(run,:));
 catch err
     paramh1 = [10 10 10 10 10];
      Covb = eye(5);
     t_est_nls1 = 0;
 end
 matrice_run_nls_impr(run,:) = paramh1;
 matrice_run_nls_t_impr(run,:) = t_est_nls1;

  matrice_variance_nls_impr = diag(Covb)'; 
  matrice_run_nls_var_impr(run,:) = matrice_variance_nls_impr(1:3);
  

 nls_a_b_c_impr  =intervalle_confiance_nls(matrice_variance_nls_impr(1:3),paramh1(1:3),0.05);
 matrice_run_nls_a_impr(run,:)  = nls_a_b_c_impr(1,:);
 matrice_run_nls_b_impr(run,:)  = nls_a_b_c_impr(2,:);
 matrice_run_nls_c_impr(run,:)  = nls_a_b_c_impr(2+1,:);
 
 
    end
    C_gm{ocur,nb_obs} = matrice_run_gm;
    C_oc{ocur,nb_obs} = matrice_run_oc;
    C_oc_var{ocur,nb_obs} = matrice_run_oc_var;
    C_oc_non_min{ocur,nb_obs} = matrice_run_oc_non_min;
    C_oc_var_non_min{ocur,nb_obs} = matrice_run_oc_var_non_min;
    C_nls{ocur,nb_obs} = matrice_run_nls;
    C_nls_var{ocur,nb_obs} = matrice_run_nls_var;
	C_gm_ci{ocur,nb_obs} = matrice_run_gm_ci;
    C_oc_ci{ocur,nb_obs} = matrice_run_oc_ci;
    C_oc_ci_non_min{ocur,nb_obs} = matrice_run_oc_ci_non_min;
    
    C_oc_a{ocur,nb_obs} = matrice_run_oc_a;
    C_oc_b{ocur,nb_obs} = matrice_run_oc_b;
    C_oc_c{ocur,nb_obs} = matrice_run_oc_c;
    
    C_oc_a_non_min{ocur,nb_obs} = matrice_run_oc_a_non_min;
    C_oc_b_non_min{ocur,nb_obs} = matrice_run_oc_b_non_min;
    C_oc_c_non_min{ocur,nb_obs} = matrice_run_oc_c_non_min;
     
    C_nls_a{ocur,nb_obs} = matrice_run_nls_a;
    C_nls_b{ocur,nb_obs} = matrice_run_nls_b;
    C_nls_c{ocur,nb_obs} = matrice_run_nls_c;
    
    C_gm_t{ocur,nb_obs} = matrice_run_gm_t;
    C_oc_t{ocur,nb_obs} = matrice_run_oc_t;
    C_oc_non_min_t{ocur,nb_obs} = matrice_run_oc_non_min_t;
    C_nls_t{ocur,nb_obs} = matrice_run_nls_t;
  
    C_nls_impr{ocur,nb_obs} = matrice_run_nls_impr;
    C_nls_var_impr{ocur,nb_obs} = matrice_run_nls_var_impr;    
    C_nls_a_impr{ocur,nb_obs} = matrice_run_nls_a_impr;
    C_nls_b_impr{ocur,nb_obs} = matrice_run_nls_b_impr;
    C_nls_c_impr{ocur,nb_obs} = matrice_run_nls_c_impr;
    C_nls_t_impr{ocur,nb_obs} = matrice_run_nls_t_impr;
    
     repertoire = 'resultat_simulation/FitzNagumo/';

    if nb_obs == 1
        repertoire = [repertoire,'pop_400/'];
        nom_fichier = ['test',num2str(ocur),'.mat'];
        repertoire = [repertoire,nom_fichier];
        save(repertoire,'C_gm','C_oc','C_oc_non_min','C_oc_var','C_oc_var_non_min','C_gm_ci','C_oc_ci','C_oc_ci_non_min','C_nls','C_nls_var','C_oc_a','C_oc_b','C_oc_c','C_oc_a_non_min','C_oc_b_non_min','C_oc_c_non_min',...
        'C_nls_a','C_nls_b','C_nls_c','C_nls_impr','C_nls_var_impr','C_nls_a_impr','C_nls_b_impr','C_nls_c_impr','C_gm_t','C_oc_t','C_oc_non_min_t','C_nls_t','C_nls_t_impr');
    end
       
    if nb_obs == 2
        repertoire = [repertoire,'pop_200/'];
        nom_fichier = ['test',num2str(ocur),'.mat'];
        repertoire = [repertoire,nom_fichier];
        save(repertoire,'C_gm','C_oc','C_oc_non_min','C_oc_var','C_oc_var_non_min','C_gm_ci','C_oc_ci','C_oc_ci_non_min','C_nls','C_nls_var','C_oc_a','C_oc_b','C_oc_c','C_oc_a_non_min','C_oc_b_non_min','C_oc_c_non_min',...
        'C_nls_a','C_nls_b','C_nls_c','C_nls_impr','C_nls_var_impr','C_nls_a_impr','C_nls_b_impr','C_nls_c_impr','C_gm_t','C_oc_t','C_oc_non_min_t','C_nls_t','C_nls_t_impr');
  end
    
    if nb_obs == 3
        repertoire = [repertoire,'pop_50/'];
        nom_fichier = ['test',num2str(ocur),'.mat'];
        repertoire = [repertoire,nom_fichier];
        save(repertoire,'C_gm','C_oc','C_oc_non_min','C_oc_var','C_oc_var_non_min','C_gm_ci','C_oc_ci','C_oc_ci_non_min','C_nls','C_nls_var','C_oc_a','C_oc_b','C_oc_c','C_oc_a_non_min','C_oc_b_non_min','C_oc_c_non_min',...
        'C_nls_a','C_nls_b','C_nls_c','C_nls_impr','C_nls_var_impr','C_nls_a_impr','C_nls_b_impr','C_nls_c_impr','C_gm_t','C_oc_t','C_oc_non_min_t','C_nls_t','C_nls_t_impr');
   end
    
    
end

end
