function param_est = est_nls_influenza(param_est,C_I_est,data_CD8,time_obs,bs_dend,delay)
    %data_C8 : cell_array de taille time_obs. Chaque cellules contient une
    %matrices de taille (nb_individu*3)

    function res_temp = dend_cell(t)
        res_temp = bs_dend.calcul_prediction(t);
        res_temp = arrayfun(@(x)10^x,res_temp);
    end

    
    function residu = func_eco(theta)
     %   theta
    C_I_CD8 = theta(6:8);    
    p_m = theta(1);
    p_s = theta(2);
    g_l = theta(3);

    g_ms = theta(4);
    g_sl = theta(5);

    function dy = equ(t,y)
      dy = zeros(2+1,1);
       dy(1) = (p_m*dend_cell(t-delay)-g_ms);
       dy(2) = (p_s*dend_cell(t-delay)-g_sl)+g_ms*exp(y(1)-y(2));
       dy(3) = g_sl*exp(y(2)-y(3))-g_l;
    end

    vecteur = time_obs(1):(time_obs(end) - time_obs(1))/200:time_obs(end);
    sol_ODE = ode45(@equ,vecteur,C_I_CD8);
    
    point_sim = deval(sol_ODE,time_obs);
    
    residu=0;
    for ni = 1 : length(time_obs)
        mat_obs = data_CD8{ni};
        point_sim_obs = point_sim(:,ni);
        
        if ~isempty(find(mat_obs(:,3)==-inf))
            indice = find(mat_obs(:,3)==-inf);
            mat_obs(indice,3) = point_sim_obs(3);
        end
        
        [nb_ligne nb_col] = size(mat_obs);
        %mat_obs
        point_sim_obs= point_sim_obs';
        %repmat(point_sim_obs,nb_ligne,1)
        residu = residu + sum(sum((mat_obs - repmat(point_sim_obs,nb_ligne,1)).^2));
    end
    end

    tol = 10^-10;
   options = optimset('TolFun',tol,'TolX',tol,'Jacobian','off','MaxFunEvals',+inf,'MaxIter',20000);
%    lb = zeros(10,1);
%    lb(1) = 0.01;
%    lb(7) = 100;
%    up = Inf.*ones(10,1);
%    alpha_ini = 9*(10^-5).*ones(nb_alpha,1);
   param_est =  lsqnonlin(@func_eco,[param_est C_I_est],[],[],options);
    
  
end