function [res_est var_param_min intervalle_confiance] = minimize_variance_influenza(bs,func_test,L,bs_dend,delay)

X_l = compute_xl_influenza(bs,func_test,bs_dend,delay,L);
Y_l = compute_yl_influenza(bs,func_test,L);
par_temp = -(pinv(X_l'*X_l)*X_l'*Y_l)';

tol = 10^-6;
ecart = tol+1;

nbiter = 0;
while ecart > tol && nbiter < 30
    nbiter= nbiter+1;
    var_coeff = compute_variance_coeff_influenza(bs,func_test,L,par_temp);
    Weight = pinv(var_coeff);
    [P U] = eig(Weight);
    diag_U = diag(U)'
    
    nv_par_temp = -pinv(X_l'*Weight*X_l)*X_l'*Weight*Y_l
    
    ecart = sum(((par_temp-nv_par_temp')./par_temp).^2);
    par_temp = nv_par_temp';
end

    res_est = par_temp;
    var_param_min = compute_variance_param_influenza(bs,func_test,L,par_temp,bs_dend,delay,Weight);
    
    alpha = 0.05;
    
    par_temp = reshape(par_temp,length(par_temp),1);
    p = norminv(1-alpha/2);
    Var = diag(var_param_min);
    Var =arrayfun(@sqrt,Var);
    
    intervalle_confiance(:,1) = par_temp - p*Var;
    intervalle_confiance(:,2) = par_temp + p*Var;

end