function [beta COVB] = nls_curve_influenza(param_est,C_I_est,data_CD8,time_obs,bs_dend,delay)

 function res_temp = dend_cell(t)
        res_temp = bs_dend.calcul_prediction(t);
        res_temp = arrayfun(@(x)10^x,res_temp);
 end

vecteur_donnee_gen = zeros(180,1);
indice = 1;
 for ni = 1 : length(time_obs)
        mat_obs = data_CD8{ni};
        size_obs = size(mat_obs);
        
        if ~isempty(find(mat_obs(:,3)==-inf))
            indice = find(mat_obs(:,3)==-inf);
            mat_obs(indice,3) = Nan;
        end
        
        nv_mat_obs = reshape(mat_obs,size_obs(1)*size_obs(2),1);
        vecteur_donnee_gen(indice:length(nv_mat_obs)+indice-1,1) = nv_mat_obs;
        indice = length(nv_mat_obs)+indice;
 end
    
    function vecteur_pred = func_eco(theta,donnee)
      %  theta
    C_I_CD8 = theta(6:8);    
    p_m = theta(1);
    p_s = theta(2);
    g_l = theta(3);

    g_ms = theta(4);
    g_sl = theta(5);

    function dy = equ(t,y)
      dy = zeros(2+1,1);
       dy(1) = (p_m*dend_cell(t-delay)-g_ms);
       dy(2) = (p_s*dend_cell(t-delay)-g_sl)+g_ms*exp(y(1)-y(2));
       dy(3) = g_sl*exp(y(2)-y(3))-g_l;
    end

    vecteur = time_obs(1):(time_obs(end) - time_obs(1))/200:time_obs(end);
    sol_ODE = ode45(@equ,vecteur,C_I_CD8);
    
    point_sim = deval(sol_ODE,time_obs);
    
    vecteur_pred = zeros(180,1);
    indice_pred =1;
    for nj = 1 : length(time_obs)
       n_mat_obs = data_CD8{nj};
       n_size_obs = size(n_mat_obs);
       
       obs_ti = point_sim(:,nj)';         
       obs_ti = repmat(obs_ti,n_size_obs(1),1);
       nv_obs_ti = reshape(obs_ti,n_size_obs(1)*n_size_obs(2),1);
       %nv_mat_obs = reshape(mat_obs,size_obs(1)*size_obs(2),1);
       vecteur_pred(indice_pred:length(nv_obs_ti)+indice_pred-1,1) = nv_obs_ti;
       indice_pred = length(nv_obs_ti)+indice_pred;

    end
    

    
    end

    tol = 10^-10;
   options = optimset('TolFun',tol,'TolX',tol,'MaxFunEvals',+inf,'MaxIter',20000);
%    lb = zeros(10,1);
%    lb(1) = 0.01;
%    lb(7) = 100;
%    up = Inf.*ones(10,1);
%    alpha_ini = 9*(10^-5).*ones(nb_alpha,1);
    [beta,r,J,COVB] = nlinfit([],vecteur_donnee_gen,@func_eco,[param_est C_I_est],options);
    
  
end