function r = der_sec_vect_param_influenza_fun_gs(t,fd_cell,p,param_time,func_dend,knots)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fhndfdx
%
% The derivative of the FitzHugh Nagumo equations with respect to x 
% at times t with parameters p. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

vx = cell2mat(eval_fdcell(t,fd_cell,0)');
r = cell(3,3,length(p));
r(1:3,1:3,1:length(p)) = {0};

    log_p_m = p(1);
    log_p_s = p(2);

    log_g_ms = p(3);
    log_g_sl = p(4);
    
    param_beta = p(5:end);
    
    
    p_m = exp(log_p_m);
    p_s = exp(log_p_s);

    g_ms = exp(log_g_ms);
    g_sl = exp(log_g_sl);
        
    
    delay = param_time(1);
    time_shift = param_time(2);
 
%      %res_t(1) = (p_m*func_dend(t+time_shift-delay)-g_ms);
%     %res_t(2) = (p_s*func_dend(t+time_shift-delay)-g_sl)+g_ms*exp(vx(1)-vx(2));
%     %res_t(3) = g_sl*exp(vx(2)-vx(3)) -vx(4);
%     %res_t(4) = vx(5);
%     
%     res_t(2,1)  = g_ms*exp(vx(1)-vx(2));
%     res_t(2,2)  = -g_ms*exp(vx(1)-vx(2));
%     
%     res_t(3,2)  = g_sl*exp(vx(2)-vx(3));
%     res_t(3,3)  = -g_sl*exp(vx(2)-vx(3));
%     res_t(3,4)  = -1;
%     
%     res_t(4,5)  = 1;

     r{2,1,3}  =  g_ms*exp(vx(1)-vx(2));
     r{2,2,3}  =  -g_ms*exp(vx(1)-vx(2));
     
     r{3,2,4}  =  g_sl*exp(vx(2)-vx(3));
     r{3,3,4}  =   -g_sl*exp(vx(2)-vx(3));
     
end