function r = der_vect_param_influenza_fun_gs(t,fd_cell,p,param_time,func_dend,knots)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fhndfdp
%
% The derivative of the FitzHugh Nagumo equations with respect to p
% at times t with parameters p. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

vx = eval_fdcell(t,fd_cell,0);
r = cell(3,length(p));
r(1:3,1:length(p)) = {0};

    log_p_m = p(1);
    log_p_s = p(2);

    log_g_ms = p(3);
    log_g_sl = p(4);
    
    param_beta = reshape(p(5:end),length(p(5:end)),1);  
    
    p_m = exp(log_p_m);
    p_s = exp(log_p_s);

    g_ms = exp(log_g_ms);
    g_sl = exp(log_g_sl);        
    
    delay = param_time(1);
    time_shift = param_time(2);
    val_func_t = bsplineM(t+time_shift ,[5 14],3,0,0);
    
    r{1,1} = p_m*func_dend(t+time_shift-delay);
    r{1,3} = -g_ms;
    
    r{2,2} = p_s*func_dend(t+time_shift-delay);   
    r{2,3} = g_ms*exp(vx{1}-vx{2});
    r{2,4} = -g_sl;

    r{3,4} = g_sl*exp(vx{2}-vx{3});
    
  val_der_beta = bsplineM(t,knots,4,0,0)';
    for nbeta = 1 : length(param_beta)        
        r{3,nbeta+4} = -val_der_beta(nbeta,:)';
    end
    

end