function [res_err_pred state_rec_l2err]= compute_prediction_error_pontryagin(est_param,theta,nb_obs,deb,fin,x_0,est_x_0,mat_obs,vector_field,std,est_control,true_control,param_fixe)

    pas = (fin-deb)/nb_obs;
    Int_ode_solve = deb:pas:fin; 
    dim_syst = length(mat_obs(1,:));
    dim_obs = length(mat_obs(:,1));

    
    if nargin < 13
        param_fixe = [];
    end
    pres_control = 1;
    
    if nargin < 11
        est_control = [];
    end
    
    if isempty(est_control)
        pres_control = 0;
    end

    pres_true_control = 1;
    
    if nargin < 12
        true_control = [];
    end
    
    if isempty(true_control)
        pres_true_control = 0;
    end

  
    
  
    function res_t = pred_champ_vect_state_param(t,vx)
        pert = 0;
        if pres_control ==1
            pert = reshape(est_control(t),dim_syst,1);
        end
        res_t = vector_field(t,vx,est_param,param_fixe)+ pert;
    end

   function res_t = true_champ_vect_state_param(t,vx)
        pert = 0;
        if pres_true_control ==1
            pert = reshape(true_control(t),dim_syst,1);
        end
        res_t = vector_field(t,vx,theta,param_fixe)+ pert;
    end
       
    [res_t_sim x_pred] = ode45(@pred_champ_vect_state_param,Int_ode_solve,est_x_0,Int_ode_solve);    
    [res_t_sim x_true]= ode45(@true_champ_vect_state_param,Int_ode_solve,x_0,Int_ode_solve);
    
    sol_x_pred = ode45(@pred_champ_vect_state_param,Int_ode_solve,est_x_0,Int_ode_solve);    
    sol_x_true = ode45(@true_champ_vect_state_param,Int_ode_solve,x_0,Int_ode_solve);
    
    
    pred_obs = zeros(length(res_t_sim),dim_obs);
    true_obs = zeros(length(res_t_sim),dim_obs);
    
    for ni = 1 :  length(res_t_sim)
        pred_t_ni = x_pred(ni,:)';
        pred_obs(ni,:) = (mat_obs*pred_t_ni)';
        
        true_t_ni = x_true(ni,:)';
        true_obs(ni,:) = (mat_obs*true_t_ni)';
    end

            
     res_err_pred = 0;
     nb_gen = 100;
             
            for nb_g = 1 : nb_gen 
             res_y_bruite =  true_obs + std*randn(length(res_t_sim),dim_obs);
             res_err_pred = res_err_pred + sqrt(pas*sum(sum((res_y_bruite - pred_obs).^2)));
            end
            
            res_err_pred = res_err_pred/nb_gen;
       
    function res_t = erreur_pointwise_state(t)
        res_t = (deval(sol_x_pred,t) - deval(sol_x_true,t)).^2;
    end

    state_rec_l2err = sqrt(quadv(@(t)(erreur_pointwise_state(t)),res_t_sim(1),res_t_sim(end)));

end