function res =  calcul_direct_lisseur_pol(r,X,num_var,order)
% Calcul les valeurs attendu pour la derive de la base de polynome par morceaux d'ordre order pour les differentes valeurs contenu dans le vecteur X
% Renvoie une matrice de taille : taille de X * dimension des observations
% Argument :
% r ..... objet piecePolynome contenant la base de spline
% X...... vecteur contenant les valeurs 
% order..... ordre de la derive (par defaut 0)

obs = getObservation(r);
Kernel = getFoncKernel(r);

T = obs.getTimes(); 
p = getOrdre(r) ;
C = getBandwiths(r);

  if  nargin <= 2+1 
      order = 0;
  end

  res = zeros(length(T),length(X));
for i = 1:length(X)
vecteur = T - X(i);
Kh = diag(arrayfun(Kernel,vecteur,C{1,num_var}.*ones(length(T),1)));
Xx = ones(length(T),p+1);
for j = 1 : p
Xx(:,j+1) = vecteur.*Xx(:,j);
end

mat_inter_num = Xx'*Kh;
mat_inter_den = Xx'*Kh*Xx;
res_mat = mat_inter_den\mat_inter_num;
res(:,i) = (res_mat(order+1,:))';
end

  end
