function nv_x_res =  calcul_prediction_direct_pol(r,X,order,base,variable)
% Calcul les valeurs attendu pour la derive de la base de polynome par morceaux d'ordre order pour les differentes valeurs contenu dans le vecteur X
% Renvoie une matrice de taille : taille de X * dimension des observations
% Argument :
% r ..... objet piecePolynome contenant la base de spline
% X...... vecteur contenant les valeurs 
% order..... ordre de la derive (par defaut 0)

obs = getObservation(r);
Kernel = getFoncKernel(r);

if nargin <= 2+1
    base = 0;
end

Mat_res_c = obs.getMatrix();

T_c = obs.getTimes(); 
p = getOrdre(r) ;
C = getBandwiths(r);

  if  nargin <= 2
      order = 0;
  end

  longueur = length(C(1,:));

  
  if nargin < 5
      x_res = zeros(length(X),longueur);
  for lh = 1 : longueur
      Mat_res = Mat_res_c{lh};
      T = T_c{lh};
      mat_base = zeros(longueur,length(T));
      res = zeros(length(X),length(T));
for i = 1:length(X)
vecteur = T - X(i);
Kh = diag(arrayfun(Kernel,vecteur,C{1,lh}.*ones(length(T),1)));
Xx = ones(length(T),p+1);
for j = 1 : p
Xx(:,j+1) = vecteur.*Xx(:,j);
end

%res_mat = ((Xx')*Kh)/((Xx')*Kh*Xx);
mat_inter_num = Xx'*Kh;
mat_inter_den = Xx'*Kh*Xx;
res_mat = mat_inter_den\mat_inter_num;
res(i,:) = res_mat(order+1,:);
end

if base == 1

    mat_base(lh,:) =  res(1,:);
else
    x_res(:,lh) = res*Mat_res;
end

  end
  else
      x_res = zeros(length(X),length(variable));
      for nj = 1 : length(variable)
      
      Mat_res = Mat_res_c{variable(nj)};
      T = T_c{variable(nj)};
      mat_base = zeros(1,length(T));
      res = zeros(length(X),length(T));
        for i = 1:length(X)
        vecteur = T - X(i);
        Kh = diag(arrayfun(Kernel,vecteur,C{1,variable(nj)}.*ones(length(T),1)));
        Xx = ones(length(T),p+1);
        for j = 1 : p
            Xx(:,j+1) = vecteur.*Xx(:,j);
        end

%res_mat = ((Xx')*Kh)/((Xx')*Kh*Xx);
        mat_inter_num = Xx'*Kh;
        mat_inter_den = Xx'*Kh*Xx;
        res_mat = mat_inter_den\mat_inter_num;
        res(i,:) = res_mat(order+1,:);
        end

    if base == 1
      mat_base(nj,:) =  res(1,:);
    else
      x_res(:,nj) = res*Mat_res;
    end

%fin else    
      end
    end
  
  if base == 1
   nv_x_res =  mat_base;
  else
   nv_x_res = x_res;
  end
  
  
end