function [paramh,resnorm,residual,COVB,temps_calc]=nv_nlsode_partObs(obs,model,theta0,x00,var_obs,freeparam)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%model : structure of function handler, ode function vf(t,x,theta)
%
%freeparam : 0 = optimize in theta and x0
%            1 = optimize in theta (x0 fixed with input value x0)
%               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tic

if nargin < 6
    freeparam = 0;
end

p=length(theta0);
d=length(x00);
ObsTimes = obs.getTimes();
ObsY = obs.getMatrix();

opt=optimset('TolX',1e-10,'MaxIter',1e2,'TolFun',1e-10,'MaxFunEvals',1e4);

    if freeparam == 1
        param0=[theta0 x00];
    else
        param0= theta0;
    end

    y = cell2mat(ObsY');
    [ligne col] = size(y);
    y = reshape(y,ligne*col,1);
    X = ObsTimes{1};

    [paramh,residual,J,COVB,resnorm] = nlinfit(X,y,@fun_llinfit,param0);
    %[ypred,delta] = nlpredci(@fun_llinfit,X,paramh,residual,'covar',COVB)
    %fun_llinfit(param0,X)
    
    function sol_ode = mysol_altern(param)    
        %param
        theta=param(1:p);
        
        if freeparam == 1
           x0  =param(p+1:p+d);
        else
            x0 = x00;
        end
        
        function res_int = equ_integ(t,y)
        res_int =  model(t,y,theta);
        end

        sol_ode = ode45(@equ_integ,ObsTimes{1},x0);

    end
    
    function res = fun_llinfit(param,t)
        sol_ode = mysol_altern(param);
        res = deval(sol_ode,t)';
        res = res(:,var_obs);

        res = reshape(res,ligne*col,1);
    end
    

temps_calc = toc;
end 