function [sol_equ ci_p res_norm_p_finale] = extremal_variation_algorithm_solver(T_int,x_0,vect_field_state,vect_field_p,der_vf_state_wrt_state,der_vf_state_wrt_p,der_vf_p_wrt_state,der_vf_p_wrt_p)

iter_i = 0;
iter_max = 300;
seuil_val_fin = sqrt(sum(x_0.^2))/10^6;
norm_val_fin = seuil_val_fin+1;
dim_syst = length(x_0);
x_0 = reshape(x_0,dim_syst,1);

p_val_ini_i = ones(dim_syst,1);
C_I_ext = [x_0' p_val_ini_i' zeros(dim_syst^2,1)' reshape(eye(dim_syst),dim_syst^2,1)'];



    function dy = extended_equ(t,y)
        val_x = reshape(y(1:dim_syst),dim_syst,1); 
        val_p = reshape(y((dim_syst+1):2*dim_syst),dim_syst,1); 
        val_sens_x = y((2*dim_syst+1):(dim_syst^2+2*dim_syst));
        val_sens_p = y((dim_syst^2+2*dim_syst+1):(2*dim_syst^2+2*dim_syst));
        val_sens_x = reshape(val_sens_x,dim_syst,dim_syst); 
        val_sens_p = reshape(val_sens_p,dim_syst,dim_syst);
        
        
        dx = vect_field_state(t,val_x,val_p);
        dp = vect_field_p(t,val_x,val_p);
        
        d_sens_x = der_vf_state_wrt_state(t,val_x,val_p)*val_sens_x + der_vf_state_wrt_p(t,val_x,val_p)*val_sens_p;
        d_sens_p = der_vf_p_wrt_state(t,val_x,val_p)*val_sens_x + der_vf_p_wrt_p(t,val_x,val_p)*val_sens_p;
        
        dx_v = reshape(dx,dim_syst,1);
        dp_v = reshape(dp,dim_syst,1);
        d_sens_x_v = reshape(d_sens_x,dim_syst^2,1);
        d_sens_p_v = reshape(d_sens_p,dim_syst^2,1);
        
        dy = [dx_v' dp_v' d_sens_x_v' d_sens_p_v']';
        
    end


    while (iter_i < iter_max) && (norm_val_fin > seuil_val_fin)
        %iter_i
  
          sol_ext = ode45(@extended_equ,T_int,C_I_ext);
          val_finale = deval(sol_ext,T_int(end));
          
            %val_x_finale = reshape(val_finale(1:dim_syst),dim_syst,1); 
            val_p_finale = reshape(val_finale((dim_syst+1):2*dim_syst),dim_syst,1);
            val_sens_x_finale = val_finale((2*dim_syst+1):(dim_syst^2+2*dim_syst));
            val_sens_p_finale = val_finale((dim_syst^2+2*dim_syst+1):(2*dim_syst^2+2*dim_syst));
            %val_sens_x_finale = reshape(val_sens_x_finale,dim_syst,dim_syst); 
            val_sens_p_finale = reshape(val_sens_p_finale,dim_syst,dim_syst);
            
            p_val_ini_i_1 = p_val_ini_i - inv(val_sens_p_finale)*val_p_finale;
            
            p_val_ini_i = p_val_ini_i_1;
            C_I_ext((dim_syst+1):2*dim_syst) = p_val_ini_i;
            norm_val_fin = sqrt(sum(val_p_finale.^2))
            iter_i = iter_i+1;
          
    end
    
    
    sol_equ = sol_ext;
    ci_p =  p_val_ini_i;
    res_norm_p_finale = norm_val_fin;
        


end