function [sol_equ ci_p res_norm_p_finale] = quasilinearization_algorithm_solver(T_int,x_0,vect_field_state,vect_field_p,der_vf_state_wrt_state,der_vf_state_wrt_p,der_vf_p_wrt_state,der_vf_p_wrt_p)

iter_i = 0;
iter_max = 50;
seuil_ecart = sqrt(sum(x_0.^2))/10^6;
ecart_max = seuil_ecart+1;
dim_syst = length(x_0);
x_0 = reshape(x_0,dim_syst,1);


    function dy = equ_ini(t,y)
        val_x = reshape(y(1:dim_syst),dim_syst,1); 
        val_p = reshape(y((dim_syst+1):2*dim_syst),dim_syst,1); 
          
%        dx = vect_field_state(t,val_x,val_p);
%        dp = vect_field_p(t,val_x,val_p);
        
         dx = zeros(1,dim_syst);
         dp = zeros(1,dim_syst);
        
        dx_v = reshape(dx,dim_syst,1);
        dp_v = reshape(dp,dim_syst,1);
        
        dy = [dx_v' dp_v']';
        
    end

    function dy = equ_tr(t,y)
        val_x = reshape(y(1:dim_syst),dim_syst,1); 
        val_p = reshape(y((dim_syst+1):2*dim_syst),dim_syst,1); 
          
        dx = vect_field_state(t,val_x,val_p);
        dp = vect_field_p(t,val_x,val_p);
       
        dx_v = reshape(dx,dim_syst,1);
        dp_v = reshape(dp,dim_syst,1);
        
        dy = [dx_v' dp_v']';
        
    end


    val_p_i = ones(dim_syst,1);
    C_I_ini = [x_0' val_p_i']';
    sol_i = ode45(@equ_ini,T_int,C_I_ini);
    val_x_p = deval(sol_i,T_int);
    
    function res_t = mat_A_gen(t,sol_cur)
        val_sol_t = deval(sol_cur,t);
        val_x_t_i = reshape(val_sol_t(1:dim_syst),dim_syst,1); 
        val_p_t_i = reshape(val_sol_t((dim_syst+1):2*dim_syst),dim_syst,1);
        res_t = der_vf_state_wrt_state(t,val_x_t_i,val_p_t_i);
    end


     function res_t = mat_B_gen(t,sol_cur)
        val_sol_t = deval(sol_cur,t);
        val_x_t_i = reshape(val_sol_t(1:dim_syst),dim_syst,1); 
        val_p_t_i = reshape(val_sol_t((dim_syst+1):2*dim_syst),dim_syst,1);
        res_t = der_vf_state_wrt_p(t,val_x_t_i,val_p_t_i);
     end

    function res_t = mat_C_gen(t,sol_cur)
        val_sol_t = deval(sol_cur,t);
        val_x_t_i = reshape(val_sol_t(1:dim_syst),dim_syst,1); 
        val_p_t_i = reshape(val_sol_t((dim_syst+1):2*dim_syst),dim_syst,1);
        res_t = der_vf_p_wrt_state(t,val_x_t_i,val_p_t_i);
    end

    function res_t = mat_D_gen(t,sol_cur)
        val_sol_t = deval(sol_cur,t);
        val_x_t_i = reshape(val_sol_t(1:dim_syst),dim_syst,1); 
        val_p_t_i = reshape(val_sol_t((dim_syst+1):2*dim_syst),dim_syst,1);
        res_t = der_vf_p_wrt_p(t,val_x_t_i,val_p_t_i);
    end


    function res_t = e_x_gen(t,sol_cur)
        val_sol_t = deval(sol_cur,t);
        val_x_t_i = reshape(val_sol_t(1:dim_syst),dim_syst,1); 
        val_p_t_i = reshape(val_sol_t((dim_syst+1):2*dim_syst),dim_syst,1);
        res_der_h_x = der_vf_state_wrt_state(t,val_x_t_i,val_p_t_i);
        res_der_h_p = der_vf_state_wrt_p(t,val_x_t_i,val_p_t_i);
        val_h_t_i = vect_field_state(t,val_x_t_i,val_p_t_i);

        
        res_t = val_h_t_i - res_der_h_x*val_x_t_i - res_der_h_p*val_p_t_i; 
    end


     function res_t = e_p_gen(t,sol_cur)
        val_sol_t = deval(sol_cur,t);
        val_x_t_i = reshape(val_sol_t(1:dim_syst),dim_syst,1); 
        val_p_t_i = reshape(val_sol_t((dim_syst+1):2*dim_syst),dim_syst,1);
        res_der_g_x = der_vf_p_wrt_state(t,val_x_t_i,val_p_t_i);
        res_der_g_p = der_vf_p_wrt_p(t,val_x_t_i,val_p_t_i);
        val_g_t_i = vect_field_p(t,val_x_t_i,val_p_t_i);
        
        res_t = val_g_t_i - res_der_g_x*val_x_t_i - res_der_g_p*val_p_t_i; 
    end



    while (iter_i < iter_max) && (ecart_max > seuil_ecart)
        %iter_i
        
            Mat_A = @(t)(mat_A_gen(t,sol_i));
            Mat_B = @(t)(mat_B_gen(t,sol_i));
            Mat_C = @(t)(mat_C_gen(t,sol_i));
            Mat_D = @(t)(mat_D_gen(t,sol_i));
            
            e_x = @(t)(e_x_gen(t,sol_i));
            e_p = @(t)(e_p_gen(t,sol_i));
            
           [sol_i_1 val_p_i_1] =  sol_ode_linearized(T_int,x_0,Mat_A,Mat_B,Mat_C,Mat_D,e_x,e_p);
           
            val_x_1_p_1 = deval(sol_i_1,T_int);      
            ecart_max = max(max(abs(val_x_1_p_1 -val_x_p)))
            
            sol_i = sol_i_1;
            val_p_i = val_p_i_1;
            val_x_p = val_x_1_p_1;
            iter_i = iter_i+1;
          
    end
    
    
    C_I_fin = [x_0' val_p_i']';
    sol_equ = ode45(@equ_tr,T_int,C_I_fin);
    val_x_p_fin = deval(sol_equ,T_int(end));
    val_p_fin = val_x_p_fin((dim_syst+1):end);
    norm_val_fin = sqrt(sum(val_p_fin.*val_p_fin));
    ci_p =  val_p_i;
    res_norm_p_finale = norm_val_fin;
        


end