%% data recuperation & parameter setting
clear
load('ensemble_donne_utile.mat')
% mln, spleen and lung logtrainsformed data


%moy_T_translog = moy_T_translog(2:end-1,:)
moy_logtransform_sp = moy_logtransform(3:end-1,:);
data_infl_regroupe_sp = data_infl_regroupe(3:end-1);


 
% dendritic cell estimation
Obs_dend = Observation(data_moy(:,1),data_moy(:,2));
bs_dend = bSplines(Obs_dend);

func_inter_dend  = @(t)(bs_dend.calcul_prediction(t,0));
sample_dend = bs_dend.calcul_prediction(2:0.1:15);
sample_dend = arrayfun(@(x)10^x,sample_dend);
plot(2:0.1:15,sample_dend)

estimation_interval = [5 6 7 8 9 10 11 12 14];

rho_m = 1.15E-5;
rho_s = 2.72E-5;

sigma_m_s = 1.58E-1;
sigma_s_l = 2.50E-1;

Tau = 3.53E+0;

log_param = [  -10.8949   -9.7123   -1.4086   -0.6286];
CI_Wu = [log(4430) log(3490) log(1330) 0];
shift = 5;
log_param_ini =  [log_param   -1.5];

%% Non parametric estimation
Obs_T_infl = Observation(moy_logtransform_sp(:,1)-shift,moy_logtransform_sp(:,2:4));

bs_infl1 = bSplines(Obs_T_infl);



knots_infl = bs_infl1.getKnots();
nv_knots_infl = knots_infl;


 knots_infl2_1 = [5 7.9 8.8 11 14]-shift;  
 knots_infl2_2 = [5 8.1 14]-shift;
 knots_infl2_3 = [5 9 10.1 14]-shift;

 nv_knots_infl{1} = knots_infl2_1;
 nv_knots_infl{2} = knots_infl2_2;
 nv_knots_infl{3} = knots_infl2_3;

bs_infl1.setKnots(nv_knots_infl);
bs_infl1.erreur(1);



%%

mat_C_ext = zeros(3,5);
mat_C_ext(1:3,1:3) = eye(3);

mat_B_ext = zeros(5,4);
mat_B_ext(1:3,1:3) = eye(3);
mat_B_ext(5,4) = 1;

lambda_trial = [100 1000 10000 100000];

mat_est_infl1 = zeros(length(lambda_trial),5);
mat_errpred2_infl1 = zeros(length(lambda_trial),1);
estimator_gl = cell(length(lambda_trial),1);

    T_st = Obs_T_infl.time_obs{1};
    T_st_eval_gl = T_st(1):((T_st(9)-T_st(1))/100):T_st(9);
    intervalle_int2 = zeros(2,2);
    intervalle_int2(1,:) = [T_st(1) T_st(5)];
    intervalle_int2(2,:) = [T_st(5) T_st(9)];


    v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
  
    warning off
   for nl = 1 : length(lambda_trial)
       

          mat_U = zeros(4);
          mat_U(1:3,1:3) = lambda_trial(nl)*eye(3);
          mat_U(4,4) = 0.1;

        try
        [est_param_oca_infl1,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,log_param_ini,CI_Wu,mat_B_ext); 
        log_param_ini = est_param_oca_infl1;
         
         est_param_oca_infl1_cur =  est_param_oca_infl1(1:4);
         est_vect_CI_infl1_ext = [CI_Wu est_param_oca_infl1(5)];

         bs_u_infl1 = est_control_pontryagin(bs_infl1,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_infl1_cur,est_vect_CI_infl1_ext,mat_B_ext);
         sol_Xu_infl1 = pontryagin_compute_controlled_solution(bs_u_infl1,v_field,est_param_oca_infl1_cur,est_vect_CI_infl1_ext,mat_B_ext);
         sol_Xu_infl1_T1 = deval(sol_Xu_infl1,T_st_eval_gl);

         bs_gl_infl1 = bSplines(Observation(T_st_eval_gl,sol_Xu_infl1_T1(4,:)'));
         v_field_gl_infl1 = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau shift],@(t)(10^func_inter_dend(t)),bs_gl_infl1);


         res_err_pred2_infl1 = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_infl1,bs_u_infl1,v_field,v_field_gl_infl1,eye(3),est_param_oca_infl1_cur,est_vect_CI_infl1_ext,intervalle_int2,mat_B_ext);
                         
         mat_errpred2_infl1(nl) = res_err_pred2_infl1;
         mat_est_infl1(nl,:) = est_param_oca_infl1; 
         
         estimator_gl{nl} = bs_gl_infl1;
          
        catch     
            'echec infl1' 
            nl
            mat_errpred2_infl1(nl) = 10^100;
            mat_est_infl1(nl,:) =zeros(1,5); 
        end
        
   end
   
      %Plot functional parameter estimation  
      figure
      [~, indice_min_err_pred] = min(mat_errpred2_infl1);
      bs_gl_opt_errpred = estimator_gl{indice_min_err_pred};
       bs_gl_T1_nus =  bs_gl_opt_errpred.calcul_prediction(T_st_eval_gl);
      plot(T_st_eval_gl, bs_gl_T1_nus)
      title('Estimation delta_l misspe')